﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
namespace OmapInterface
{
    class OMapApi
    {
                
        public const int OMAP_WIN_API_VERSION = 101;
        public const int OMAP_WIN_API_FLAG = 1001;

        public const int OMAP_WIN_CMD_REGISTER = 20000;
        public const int OMAP_WIN_CMD_GET_LATLNG = 20001;
        public const int OMAP_WIN_CMD_SET_LATLNG = 20002;
        public const int OMAP_WIN_CMD_LATLNG_GEOCODE = 20003;
        public const int OMAP_WIN_CMD_SHOW_PIC = 20004;
        public const int OMAP_WIN_CMD_TIME_TO_LATLNG = 20005;
        public const int OMAP_WIN_CMD_GET_VERSION = 20006;
        public const int OMAP_WIN_CMD_SET_MAP_LOCATION = 20007;
        public const int OMAP_WIN_CMD_CLOSE = 20008;
        public const int OMAP_WIN_CMD_SAVE_CFG = 20009;
        public const int OMAP_WIN_CMD_CLEAN_TMP_OBJ = 20010;
        public const int OMAP_WIN_CMD_SET_MAP_LOCATION_EXT = 20011;
        
        public const int OMAP_API_CMD_GET_OBJ_LIST = 20100;
        public const int OMAP_API_CMD_GET_OBJ = 20101;
        public const int OMAP_API_CMD_SET_OBJ = 20102;
        public const int OMAP_API_CMD_DEL_OBJ = 20103;
        public const int OMAP_API_CMD_GET_SEL_LIST =20104;
        public const int OMAP_API_CMD_SRH_OBJ =20105;

        public const int OMAP_API_CMD_SET_SYS_COOR_POINT =20201;
        public const int OMAP_API_CMD_GET_SYS_COOR_INFO =20202;
        
        public const int OMAP_API_CMD_GET_MAP_DATA	=20301;

        public const int OMAP_API_CMD_SET_BTN	=20401;
        public const int OMAP_API_CMD_CLICK_BTN	=20402;

        public const int OMAP_API_CMD_GET_STATUS_INFO=	20501;

        public const int OMAP_RET_SYS_COOR_TYPE_ERR=	-2;
        public const int OMAP_RET_SYS_COOR_SIM_PARAM_ERR=	-1;
        public const int OMAP_RET_SYS_COOR_OK = 0;

        public const int ACTION_MOUSE_MOVE = 1;
        public const int ACTION_MOUSE_CLICK = 2;

        public const int GEO_DECODE_ERR_WAIT = -1;
        public const int GEO_DECODE_ERR_NO_DATA = -2;
        public const int MAX_API_NAME_LEN = 100;
        public const int MAX_API_DIR_WAYPOINTS = 8;

        public const int OMAP_OBJ_TYPE_GROUP = 30;
        public const int OMAP_OBJ_TYPE_SIGN = 7;
        public const int OMAP_OBJ_TYPE_TRACK = 8;
        public const int OMAP_OBJ_TYPE_SHAPE = 13;
        public const int OMAP_OBJ_TYPE_DIR = 11;

        public const int OMAP_API_ERR_WND = -1;
        public const int OMAP_API_ERR_REGISTER = -2;
        public const int OMAP_API_ERR_VER = -3;
        public const int OMAP_API_ERR_ARGV = -4;
        public const int OMAP_API_ERR_NOT_VIP = -5;
        public const int OMAP_API_ERR_DEAL = -6;
        public const int OMAP_API_ERR_NOT_VIP5 =-7;
        public const int OMAP_API_ERR_UNLOAD_OBJ = -8;
        public const string APP_CLASS_NAME = "OMapApiTest";
        private const int GWL_STYLE = -16;
        private const int WS_CHILD = 0x40000000;
       
        public const int USER = 0x0400;
        public const int OAPI_LL_TYPE_DEFAULT =0;
        public const int OAPI_LL_TYPE_REAL	=1;
        public const int OAPI_LL_TYPE_OFFSET =2;
        public const int OAPI_LL_TYPE_PLANE =3;

        // 所有对象
        public const int OBJ_SELECT_CHECK_FLAG_ALL		=	0;
        // 选中对象, 选中的文件夹自动包含所有子对象
        public const int OBJ_SELECT_CHECK_FLAG_GROUP_JOIN	=1;
        // 选中对象, 选中的文件夹不自动包括非选中子对象
        public const int OBJ_SELECT_CHECK_FLAG_SEL_ONLY = 2;
        //临时对象分组节点ID
        public const int OMAP_TMP_OBJ_GROUP_ID = 202;

        public const int WM_COPYDATA = 0x004A;

        int m_iAppID;
        byte[] m_wsAppClassName = new byte[100];
        int m_iOmapVer;

        public int OMAP_ALIGN_8_BYTE(int x)
        {
            return ((x) % 8 == 0) ? x : ((x) / 8 * 8 + 8);
        }
        public bool IS_OMAP_API_INTERRUPT_ERR(int x)
        {
            if (x == OMAP_API_ERR_NOT_VIP || x == OMAP_API_ERR_DEAL || x == OMAP_API_ERR_NOT_VIP5 || x == OMAP_API_ERR_UNLOAD_OBJ)
                return true;
            else
                return false;
        }


        public int M_iAppID
        {
            get { return m_iAppID; }
            set { m_iAppID = value; }
        }

        public byte[] M_wsAppClassName
        {
            get { return m_wsAppClassName; }
            set { m_wsAppClassName = value; }
        }

        public int M_iOmapVer
        {
            get { return m_iOmapVer; }
            set { m_iOmapVer = value; }
        }



    }
}
