﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Drawing;
namespace OmapInterface
{
    class OMapApiRealize : OMapApi
    {

        


        //经纬度
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOmapLatlng
        {
            public double lat;
            public double lng;
            public byte bReal;//是否真实经纬度
        }

        /*
地图位置
iMapID 地图id 
100文件夹：小字体谷歌地图下载文件夹
130文件夹：大字体谷歌地图下载文件夹

101文件夹：谷歌卫星图下载文件夹
160文件夹：小字体谷歌路网图下载文件夹
161文件夹：大字体谷歌路网图下载文件夹

102文件夹：小字体谷歌地形图下载文件夹
132文件夹：大字体谷歌地形图下载文件夹

103文件夹：bing卫星图下载文件夹

104文件夹：OpenCycle等高线图下载文件夹

105文件夹：小字体百度地图下载文件夹
135文件夹：大字体百度地图下载文件夹

106文件夹：小字体搜狗地图下载文件夹
136文件夹：大字体搜狗地图下载文件夹

200-1000文件夹：自定义地图下载文件夹（以地图ID命名）
*/
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOmapLocation
        {
            public tagOmapLatlng ll;
            public int iMapID;//地图类型ID
            public int iMapLevel;//地图级别
        }

        [StructLayout(LayoutKind.Sequential)]
       public struct tagOmapLocationExt{
	        public tagOmapLocation ol;
	        public byte bActive;
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
	        public uint []ret;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct tagOPhotoMapPic
        {
            public Int64 idPic;//照片id
            public uint tmPhoto;//照片拍摄时间
            public double lat;//维度
            public double lng;//经度
            public int iAction;//ACTION_MOUSE_MOVE 1  ACTION_MOUSE_CLICK 2
            public int iTmp;//备用
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct tagOmapGeoDecode
        {
            public tagOmapLatlng oll;
            public int nLevel;//地图解析的层级  如 省市区3级、省市县3级、市区2级

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 1024)]
            public byte[] strArea;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOmapGetMap{
	        public double x_lng1;
            public double y_lat1;
            public double x_lng2;
            public double y_lat2;
            public byte bRealLl;

	        public Int64 iMaxPixel;
            public int iMaxLevel;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
            public int[] ret;
        }
        [StructLayout(LayoutKind.Sequential)]
      public  struct tagOMapBtnInfo{
	        public int ret0;
	        public int iAdd;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 256)]
	        public byte []strTip;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
	        public int []ret1;
        }

        //存放收藏夹对象的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiObjectOptHdr
        {
            public ushort iVersion;//奥维版本
            public byte iType;//对象类型：文件夹、标签、轨迹、图形、路线
            //public byte bRet;//备用
            public byte bLlType;//坐标类型
            public uint idParent;//收藏夹对象的父节点的id 0表示该对象为根节点
            public uint idObj;//收藏夹对象的id
            public int ret;//节点所在位置
        }

        [StructLayout(LayoutKind.Sequential)]
        //收藏夹对象列表
        public struct tagOApiItemListV1
        {
            public uint idObj;//对象id
            public int iType;//对象类型
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称
        }
        [StructLayout(LayoutKind.Sequential)]

        public struct tagOApiObjGroupV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称

            public int nChild;//下一级子项的个数
            public int nAllChild;	//所有子项及其下属的总个数，未加载时该值也是一样
            public byte bLoadOk;	//是否加载成功

            public byte bSaveMerge;//存盘时pChild的内容是否合并存储，合并存储可大大加快载入时间，但使修改时存盘时间下降
            public byte bGroup;	//是否组合，不可展开
            public byte bAutoLoad;	//是否自动加载
            public byte iShowLevel;//是否隐藏
            public byte iShowLevelMax;//显示级别
            public byte bCrypt;	//是否加密, 如果设置了加密则自动加载将自动失效
            public byte bReadOnly;	//是否只读, 0: 不锁定, 1: 不带密码锁定, 2: 带密码锁定
            public byte bNotHotId;	//是否不响应鼠标事件
            public byte bRelate;	//是否是关联对象（目前用于标签与轨迹关联）
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] pwd;//设置的密码
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }

        //表示标签的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapSignV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] pstrComment;//标签备注
            
            public double lat;
            public double lng;
            public byte bRealLl;
            public int iAltitude;//海拔
            public int iTime;//生成时间
            public byte bEditMode;//是否可编辑
            public byte iOverlayIdx;//叠放层级
            public byte iSignAlignFlag;//标签图标对齐标志，0为默认下中对齐，1为正中对齐
            public int iSignPic;		//0:no picture,>=1 has sign picture
            public uint dwSignClr;
            public byte iPicScale;	//0:defalut,>=1 32*iPicScale/10
            public byte iTxtType;	//0:not show txt,1:show txt ,2:show text with border, 3: custom txt
            public byte iShowLevel;//标签显示级别
            public byte iShowLevelMax;	//show between iShowLevel-iShowLevelMax
            //自定义字体的信息
            tagOApiMapSignExtInfo el;
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapSignExtInfo
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strFontName;//对象名称
            public byte bFontZoomWithMap;
            public byte bFontWithBox;
            public byte iFontAlpha;
            public byte bFontEffect;
            public byte bFontBkStyle;
            public byte nFontBindLevel;
            public byte nFontMinLevel;
            public byte nFontMaxLevel;
            public int iFontSize;
            public uint dwFontClr;
            public uint dwFontBkClr;
            public float fFontRotateAngle;
            public byte bNoHotFontEvent;

            public Int64 idExt;
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.I8)]
            public Int64[] idExtBak;
        }
        //
        //struct tagOApiMapSignAttachmentV1{
        //	INT64 idAtta;
        //	union{
        //		IntPtr pData;
        //		double dAlign;
        //	};
        //	int nDataLen;
        //	unsigned int tCreate;
        //	unsigned int tModify;
        //	int nReference;
        //	char strName[MAX_API_NAME_LEN];
        //	char strExtTypeName[10];
        //	byte bNeedSaveData;
        //	byte bChange;
        //
        //	//如果是共享属性，则修改时会遍历标签，将所有关联附件都做更改
        //	byte bShare;
        //}

        //轨迹上的点的信息
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapTrackPointV1
        {
            public double lat;
            public double lng;
            public int time;//轨迹点的时间
            public int iAltitude;		// iAltitude >> 16 == 1 表示该点为新子图形(新子轨迹)的起始点即前一个点间断

            //扩展格式，用于CAD
            public double dCadBulge;
            public int iCadRet;


            public double dd;

            struct tagCadLwpLineWidth
            {
                public float fWidStart;
                public float fWidEnd;
            }

        }


        //表示轨迹的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapTrackV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] pstrComment;//标签备注
            //public tagOApiMapTrackPointV1[] pMtp;
            public double dAlign2;//对齐字段
            public int nMtp;//轨迹点数
            public byte bRealLl;	//tagOApiMapTrackPointV1中的经纬度是否真实经纬度
            public byte iTrackType;	// 轨迹类别: 自驾, 爬山 ...
            public byte iOverlayIdx;	//叠放层级
            public byte iShowLevel;//显示级别
            public byte iShowLevelMax;//show between iShowLevel-iShowLevelMax
            public byte bShowName;//是否显示轨迹名称
            public byte bEdit;//轨迹是否可编辑

            //六个自定义字段用于保存轨迹的自定义属性
            public byte iCustomType1;
            public byte iCustomType2;
            public byte iCustomType3;
            public byte iCustomType4;
            public int dwCustom1;
            public int dwCustom2;
            public tagOApiMapTrackDraw mtd;
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }
        //表示轨迹的结构体包含的点信息
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapTrackV2
        {
            //[MarshalAs(UnmanagedType.ByValArray, SizeConst = 100)]
            public tagOApiMapTrackPointV1[] pMtp;
        }

        //轨迹绘制的相关属性
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapTrackDraw
        {
            public uint dwLineClr;	//线条颜色
            public int iLineWidth;		//线宽
            public byte iLineAlpha;	//线条透明度
            public byte iShowType;		// 轨迹风格: 显示加权距离, CAD多线段 ...
            public byte iLineType;		//线型
            public byte bNeedDrawDetail;	//是否需要绘制角度、距离提示信息
            public byte bClose;			//是否闭合
        }
        //表示图形的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapShapeV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]

            public byte[] pstrComment;//标签备注
            public double dAlign1;


           // public tagOApiMapTrackPointV1[] pMtp;
            

            public int nMtp;//图形的节点数
            public byte bRealLl;

            //iShowFlag:0 不显示属性，1 显示名字 2 显示面积 3 显示名字与面积
            public byte iShowFlag;
            public byte iOverlayIdx;
            public double dStartAngle;	//当图形为两个点时，通过起始角度与终止角度表示圆、扇形、矩形
            double dEndAngle;

            public byte iLineWidth;	//线宽
            public byte iLineAlpha;	//线条透明度
            public byte iAreaAlpha;	//区域透明度
            public byte bEditMode;		//是否可编辑
            public byte iShowLevel;
            public byte iShowLevelMax;
            //外部Rgn索引，0为全部都是外部，>0为前面多少个是外部，后面是内部，用于处理镂空
            public byte iOuterRgnIdx;
            public uint dwLineClr;	//线条颜色
            public uint dwAreaClr;	//填充颜色
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }
        [StructLayout(LayoutKind.Sequential)]
       public struct tagOApiRelatePointV1{
            public double lng;
            public double lat;
            public byte bReal;
            public double x;
            public double y;	
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiSysCoorInfo{
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
            public int[] ret;

            public int iCoorType;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] hash;	// 以下情况有效, 可用于判断是否发生了变化, [0, 奥维平面坐标, 4: 墨卡托坐标时]
            public int nInfoLen;
	        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] strInfo; 
        }

        //表示图形包含的点信息
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapShapeV2
        {
            //[MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
            public tagOApiMapTrackPointV1[] pMtp;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiLatLngV1
        {
            public double lat;
            public double lng;

        }
        //表示一个导航步骤的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapDirectionsUnitV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 128)]
            public byte[] strTitle;//主步骤
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 1280)]
            public byte[,] strSubTitle;//子步骤
            public int nSubCount;	//子步骤数
            public short iType;	//交通工具类型
            public int nLl;		//llList个数
            public double dAlign1;

            // public tagOApiLatLngV1[] llList;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapDirectionsUnitV2
        {
            public tagOApiLatLngV1[] llList;
            
        }

        //表示导航路线的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapDirectionsV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称
           // public tagOApiMapDirectionsUnitV1[] pUnit;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] pstrComment;//标签备注
            public double dAlign1;
            

            public int nUnit;//导航步骤数
            [MarshalAs(UnmanagedType.ByValArray, SizeConst =128)]
            public byte[] strTitle;
            public tagMapDirectionsSrh dirSrh;
           
           

            public byte bEdit;//是否可编辑

            public byte iLineWidth;	//线宽
            public byte iLineAlpha;	//透明度
            public uint dwLineClr;	//线条颜色
            public byte iOverlayIdx;	//叠放层级
            public byte bRealLl;		//是否真实经纬度

            public byte iShowLevel;	//显示级别
            public byte iShowLevelMax;//show between iShowLevel-iShowLevelMax
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }

        //表示导航路线包含的所有的点信息
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapDirectionsV2
        {
             public tagOApiMapDirectionsUnitV1[] pUnit;
        }

        //搜索到的导航步骤
        [StructLayout(LayoutKind.Sequential)]
        public struct tagMapDirectionsSrh
        {
            public tagOApiLatLngV1 mpStart;//出发点的经纬度
            public tagOApiLatLngV1 mpEnd;//终点的经纬度
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public tagOApiLatLngV1[] mpVia;//中间导航点的经纬度
            public int iDirMode;//???
        }
        //启用非托管代码  
        [StructLayout(LayoutKind.Sequential)]
        public struct COPYDATASTRUCT
        {
            public IntPtr dwData;
            public int cbData;

            public IntPtr lpData;
        }

        [DllImport("User32.dll", EntryPoint = "SendMessageA")]
        public static extern int SendMessage(
            IntPtr hWnd,　　　  // handle to destination window   
            int Msg,　　　      // message  
            int wParam,　   // first message parameter   
            ref COPYDATASTRUCT pcd // second message parameter   
        );
        [DllImport("user32.dll", EntryPoint = "FindWindow")]
        private extern static IntPtr FindWindow(string lpClassName, string lpWindowName);

        [DllImport("msvcrt.dll", EntryPoint = "memcpy", CallingConvention = CallingConvention.Cdecl, SetLastError = false)]
        static extern void MemCopy(ref  tagOApiObjectOptHdr dest, ref tagOApiObjGroupV1 src, int count);
        [DllImport("msvcrt.dll", EntryPoint = "memcpy", CallingConvention = CallingConvention.Cdecl, SetLastError = false)]
        static extern void MemCopy(ref tagOApiLatLngV1 dest, byte[] src, int count);
       
       
        public ushort[] OApiUtf8ToUtf16(string strUtf8, ushort[] utf16, int[] pnU16)
        {
            int len = strUtf8.Length;
            ushort[] wszString;
            if (utf16 != null)
                wszString = utf16;
            else
                wszString = new ushort[len + 1];

            if (pnU16 != null)
            {
                pnU16[0] = 0;
            }

            byte[] u8 = System.Text.Encoding.Default.GetBytes(strUtf8);
            int i;
            int wSta = 0;
            for (i = 0; i < len; i++)
            {
                if (wSta == 316)
                    wSta = wSta;
                if (u8[i] == 0)
                    break;
                else if (u8[i] < 128)
                {
                    wszString[wSta++] = u8[i];
                }
                else if (u8[i] >= 192 && u8[i] < 224)
                {
                    if (i >= len - 1)
                        break;//invalid
                    if (!(u8[i + 1] >= 128 && u8[i + 1] < 192))
                        break;//invalid

                    wszString[wSta++] = (ushort)(((u8[i] - 192) << 6) + (u8[i + 1] - 128));
                    i++;
                }
                else if (u8[i] >= 224 && u8[i] < 240)
                {
                    if (i >= len - 2)
                        break;//invalid
                    if (!(u8[i + 1] >= 128 && u8[i + 1] < 192))
                        break;//invalid
                    if (!(u8[i + 2] >= 128 && u8[i + 2] < 192))
                        break;//invalid

                    wszString[wSta++] = (ushort)(((u8[i] - 224) << 12) + ((u8[i + 1] - 128) << 6) + (u8[i + 2] - 128));
                    i += 2;
                }
                else
                {
                    //ignore utf32
                    if (u8[i] >= 240 && u8[i] < 248)
                    {
                        i += 3;
                    }
                    else if (u8[i] >= 248 && u8[i] < 252)
                    {
                        i += 4;
                    }
                    else if (u8[i] >= 252 && u8[i] < 254)
                    {
                        i += 5;
                    }
                    else
                    {
                        //invalid utf8 code
                        break;
                    }
                }
            }
            wszString[wSta] = 0;

            if (pnU16 != null)
                pnU16[0] = wSta;
            return wszString;
        }

        int OApiUtf16ToUtf8(ushort[] wsUtf16, byte[] strUtf8, int nBuf)
        {
            int i;
            int iSta = 0;
            for (i = 0; wsUtf16[i] != 0 && iSta < nBuf - 1; i++)
            {
                if (wsUtf16[i] < 0x80)
                    strUtf8[iSta++] = (byte)wsUtf16[i];
                else if (wsUtf16[i] < 0x800)
                {
                    if (iSta >= nBuf - 2)
                        break;

                    strUtf8[iSta++] = (byte)((wsUtf16[i] >> 6) | 0xc0);
                    strUtf8[iSta++] = (byte)((wsUtf16[i] & 0x3f) | 0x80);
                }
                else
                {
                    if (iSta >= nBuf - 3)
                        break;

                    strUtf8[iSta++] = (byte)((wsUtf16[i] >> 12) | 0xe0);
                    strUtf8[iSta++] = (byte)(((wsUtf16[i] >> 6) & 0x3f) | 0x80);
                    strUtf8[iSta++] = (byte)((wsUtf16[i] & 0x3f) | 0x80);
                }
            }
            strUtf8[iSta] = 0;
            return iSta;
        }

        tagOApiObjectOptHdr OApiNewOptHdr(int iExtLen)
        {
            tagOApiObjectOptHdr pOoh = new tagOApiObjectOptHdr();

            pOoh.iVersion = OMAP_WIN_API_VERSION;
            return pOoh;
        }

        public void OMapApi()
        {
            M_iAppID = 0;
            M_iOmapVer = 0;
            for (int i = 0; i < 100; i++)
            {
                M_wsAppClassName[i] = 0;
            }
        }

        //将字符串转换宽字符
        public static byte[] setByte2(string str, int len)
        {
            byte[] b = Encoding.Default.GetBytes(str);

            byte[] unicodeBytes = Encoding.Convert(Encoding.Default, Encoding.Unicode, b);
            byte[] s = new byte[len];
            for (int i = 0; i < unicodeBytes.Length; i++)
            {
                s[i] = unicodeBytes[i];
            }
            for (int i = unicodeBytes.Length; i < len; i++)
            {
                s[i] = 0;
            }
            return s;
        }

        //将类名发送给客户端
        void RegisterToOmap()
        {
            IntPtr hwnd = FindWindow("omapWin", null);
            if (hwnd == IntPtr.Zero)
                return;

            byte[] sarr = setByte2(APP_CLASS_NAME,(APP_CLASS_NAME.Length+1)*2);//转换成宽字符
            
            int len = sarr.Length;

            COPYDATASTRUCT cds = new COPYDATASTRUCT();

            cds.dwData = (IntPtr)OMAP_WIN_CMD_REGISTER;

            cds.cbData = 24;
            GCHandle GC = GCHandle.Alloc(sarr, GCHandleType.Pinned);
            IntPtr structPtr = GC.AddrOfPinnedObject();
            //将byte数组拷贝到分配好的内存空间
            Marshal.Copy(sarr, 0, structPtr, len);

            cds.lpData = structPtr;

            M_iAppID = SendMessage(hwnd, WM_COPYDATA, OMAP_WIN_API_FLAG, ref cds);
            if (M_iAppID != 0)
            {
                COPYDATASTRUCT cd2 = new COPYDATASTRUCT();
                cd2.dwData = (IntPtr)((M_iAppID << 16) | OMAP_WIN_CMD_GET_VERSION);
                M_iOmapVer = SendMessage(hwnd, WM_COPYDATA, OMAP_WIN_API_FLAG, ref cd2);
                if (M_iOmapVer < 0)
                {
                    M_iOmapVer = 0;
                }
            }

        }

        bool CmdCheck(int iCmdId)
        {
            if (M_iOmapVer < 621 && (iCmdId == OMAP_WIN_CMD_SET_MAP_LOCATION || iCmdId == OMAP_API_CMD_GET_OBJ_LIST
        || iCmdId == OMAP_API_CMD_GET_OBJ || iCmdId == OMAP_API_CMD_SET_OBJ || iCmdId == OMAP_API_CMD_DEL_OBJ))
                return false;
            return true;
        }

        //pData类型为struct
        public int SendMessageToOmap(int iCmdId, object pData, int nData)
        {
            
            IntPtr hwnd = FindWindow("omapWin", null);

            if (hwnd == IntPtr.Zero)
            {
                M_iAppID = 0;
                M_iOmapVer = 0;
                return OMAP_API_ERR_WND;
            }

            if (M_iAppID == 0)
                RegisterToOmap();
            if (M_iAppID == 0)
                return OMAP_API_ERR_REGISTER;

            if (!CmdCheck(iCmdId))
                return OMAP_API_ERR_VER;

            COPYDATASTRUCT cd = new COPYDATASTRUCT();

            if (pData != null)
            {
 
                    byte[] Bytes = new byte[nData];
                    //根据定义的尺寸分配内存块
                    GCHandle GC = GCHandle.Alloc(Bytes, GCHandleType.Pinned);
                    IntPtr ptr1 = GC.AddrOfPinnedObject();
                    //获得Struct对应的IntPtr
                    Marshal.StructureToPtr(pData, ptr1, true);
                    cd.lpData = ptr1;

            }
            else
                cd.lpData = IntPtr.Zero;

            cd.dwData = (IntPtr)((M_iAppID << 16) | iCmdId);
            cd.cbData = nData;


            int r = SendMessage(hwnd, WM_COPYDATA, OMAP_WIN_API_FLAG, ref cd);
            int ret = 0;
            if (IS_OMAP_API_INTERRUPT_ERR(r))
            {
                ret = (int)r;
                r = 0;
            }
            if (r < 0)
            {
                M_iAppID = 0;
                M_iOmapVer = 0;
                RegisterToOmap();
                if (M_iAppID == 0)
                    return OMAP_API_ERR_REGISTER;
                if (!CmdCheck(iCmdId))
                    return OMAP_API_ERR_VER;

                r = SendMessage(hwnd, WM_COPYDATA, OMAP_WIN_API_FLAG, ref cd);
                if (r == OMAP_API_ERR_NOT_VIP || r == OMAP_API_ERR_DEAL)
                    ret = (int)r;
            }
            return ret;
        }

        public int SendMessageToOmap(int iCmdId, object pData, int nData, Int64 plResult)
        {

            IntPtr hwnd = FindWindow("omapWin", null);

            if (hwnd == IntPtr.Zero)
            {
                M_iAppID = 0;
                M_iOmapVer = 0;
                return OMAP_API_ERR_WND;
            }

            if (M_iAppID == 0)
                RegisterToOmap();
            if (M_iAppID == 0)
                return OMAP_API_ERR_REGISTER;

            if (!CmdCheck(iCmdId))
                return OMAP_API_ERR_VER;

            COPYDATASTRUCT cd = new COPYDATASTRUCT();

            if (pData != null)
            {

                byte[] Bytes = new byte[nData];
                //根据定义的尺寸分配内存块
                GCHandle GC = GCHandle.Alloc(Bytes, GCHandleType.Pinned);
                IntPtr ptr1 = GC.AddrOfPinnedObject();

                //获得Struct对应的IntPtr
                Marshal.StructureToPtr(pData, ptr1, true);
                cd.lpData = ptr1;

            }
            else
                cd.lpData = IntPtr.Zero;

            cd.dwData = (IntPtr)((M_iAppID << 16) | iCmdId);
            cd.cbData = nData;


            int r = SendMessage(hwnd, WM_COPYDATA, OMAP_WIN_API_FLAG, ref cd);
            Int64 lResult = r;
            int ret = 0;
            if (IS_OMAP_API_INTERRUPT_ERR(r))
            {
                ret = (int)r;
                r = 0;
            }
            if (r < 0)
            {
                M_iAppID = 0;
                M_iOmapVer = 0;
                RegisterToOmap();
                if (M_iAppID == 0)
                    return OMAP_API_ERR_REGISTER;
                if (!CmdCheck(iCmdId))
                    return OMAP_API_ERR_VER;

                r = SendMessage(hwnd, WM_COPYDATA, OMAP_WIN_API_FLAG, ref cd);
                lResult = r;
                if (r == OMAP_API_ERR_NOT_VIP || r == OMAP_API_ERR_DEAL)
                    ret = (int)r;
            }
            
                plResult = lResult;
            return ret;
        }

        //设置标签
        public void SetOmapTmpSign(double lat, double lng, bool bGcj02)
        {
            tagOmapLatlng oll = new tagOmapLatlng();
            oll.bReal = (byte)(bGcj02 ? 0 : 1);
            oll.lat = lat;
            oll.lng = lng;

            
            SendMessageToOmap(OMAP_WIN_CMD_SET_LATLNG, oll, Marshal.SizeOf(oll));

        }

        //地址解析
        public void GeoDecodeLatlng(double lat, double lng, bool bGcj02)
        {
            tagOmapGeoDecode ogd = new tagOmapGeoDecode();
            ogd.oll.bReal = (byte)(bGcj02 ? 0 : 1);
            ogd.oll.lat = lat;
            ogd.oll.lng = lng;
            
            SendMessageToOmap(OMAP_WIN_CMD_LATLNG_GEOCODE, ogd, Marshal.SizeOf(ogd));
        }
        //设置地图位置
        public int SetOmapLevelAndLocation(int iMapID, int iMapLevel, double lng, double lat)
        {
    	tagOmapLocation ol = new tagOmapLocation();
	    
	    ol.iMapID = iMapID;
	    ol.iMapLevel = iMapLevel;
	    ol.ll.lat = lat;
	    ol.ll.lng = lng;
	    return SendMessageToOmap(OMAP_WIN_CMD_SET_MAP_LOCATION, ol,Marshal.SizeOf(ol));
        }

        //设置地图位置
        public int SetOmapLevelAndLocationExt(int iMapID, int iMapLevel, double x_lng, double y_lat, byte bActive, byte bReal)
        {
            tagOmapLocationExt ole = new tagOmapLocationExt();
            ole.ol.iMapID = iMapID;
            ole.ol.iMapLevel = iMapLevel;
            ole.ol.ll.lat = y_lat;
            ole.ol.ll.lng = x_lng;
            ole.ol.ll.bReal = bReal;
            ole.bActive = bActive;
            return SendMessageToOmap(OMAP_WIN_CMD_SET_MAP_LOCATION_EXT, ole, Marshal.SizeOf(ole));
        }

        //清空临时对象
        public void CleanOmapTmpObject()
        {
            SendMessageToOmap(OMAP_WIN_CMD_CLEAN_TMP_OBJ, null, 0);
        }

        //获取收藏夹对象列表
        //idParent：要获取的父节点的ID，0表示根节点  idObj为1表示取根节点
        public int GetOmapObjectList(uint idParent)
        {
            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(0);
            pOoh.idObj = idParent == 0 ? 1 : idParent;
            
            int r = SendMessageToOmap(OMAP_API_CMD_GET_OBJ_LIST, pOoh, Marshal.SizeOf(pOoh));
            return r;
        }

        //取收藏夹对象
        public int GetOmapObject(uint idObj,byte bLlType)
        {
            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(0);
            pOoh.idObj = idObj;
            pOoh.bLlType = bLlType;
            int r = SendMessageToOmap(OMAP_API_CMD_GET_OBJ, pOoh, Marshal.SizeOf(pOoh));
            return r;
        }

        //删除收藏夹对象
        public int DelOmapObject(uint[] pidList, int nId)
        {
            if (nId <= 0)
            {
                return OMAP_API_ERR_ARGV;
            }

            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(nId * 4);
           
                int size = Marshal.SizeOf(pOoh) + nId * 4;
                byte[] bytess = new byte[size];
                byte[] plist = new byte[nId * 4];
                byte[] bytes = new byte[4];
                for (int i = 0; i < nId; i++)
                {
                    
                    bytes=System.BitConverter.GetBytes(pidList[i]);
                    Array.Copy(bytes, 0, plist, i * 4, 4); 
                }
                    
                    IntPtr buffer = Marshal.AllocHGlobal(Marshal.SizeOf(pOoh));
                    Marshal.StructureToPtr(pOoh, buffer, true);
                    
                    Marshal.Copy(buffer, bytess,0,size-nId*4);
                    Array.Copy(plist,0,bytess,size-nId*4,nId*4);
                    
                    Marshal.FreeHGlobal(buffer);
                    IntPtr buf = Marshal.AllocHGlobal(size);
                    Marshal.Copy(bytess, 0, buf, size);

                    int r = SendIntptrMessageToOmap(OMAP_API_CMD_DEL_OBJ, buf, size);
                    return r;
        }

        public int GetOmapSelectList(int iFlag)
        {
            // iFlag支持的参数为OBJ_SELECT_CHECK_FLAG_GROUP_JOIN, OBJ_SELECT_CHECK_FLAG_SEL_ONLY
            int iExtLen = sizeof(int);
            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(iExtLen);
            int size = Marshal.SizeOf(pOoh) + iExtLen;
            byte[] bytes = new byte[size];
            IntPtr buffer1 = Marshal.AllocHGlobal(Marshal.SizeOf(pOoh));
            Marshal.StructureToPtr(pOoh, buffer1, true);
            Marshal.Copy(buffer1, bytes, 0, Marshal.SizeOf(pOoh));
            Marshal.FreeHGlobal(buffer1);
            byte[] intBuff = BitConverter.GetBytes(iFlag);
            Array.Copy(intBuff, 0, bytes, size - iExtLen, iExtLen);
            IntPtr buf = Marshal.AllocHGlobal(size);
            Marshal.Copy(bytes, 0, buf, size);

            int r = SendIntptrMessageToOmap(OMAP_API_CMD_GET_SEL_LIST, buf, size);
            Marshal.FreeHGlobal(buf);
            return r;
        }

        public int SrhOmapObject(byte[] strName,uint idParent,int iType)
        {
            // idParent为0时表示搜索整个收藏夹, 注意与传入收藏夹ID时效果是不一样的
            // iType为0时表示不限制类型
            const int iExtLen = MAX_API_NAME_LEN;
            byte[] strName1 = new byte[iExtLen];
            if(strName!=null)
            {
                Array.Copy(strName, strName1, iExtLen);
                
            }
            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(iExtLen);
            pOoh.idParent = idParent;
            pOoh.iType = (byte)iType;
            int size = Marshal.SizeOf(pOoh) + iExtLen;
            byte[] bytes = new byte[size];
            IntPtr buffer1 = Marshal.AllocHGlobal(Marshal.SizeOf(pOoh));
            Marshal.StructureToPtr(pOoh, buffer1, true);
            Marshal.Copy(buffer1, bytes, 0, Marshal.SizeOf(pOoh));
            Marshal.FreeHGlobal(buffer1);

            Array.Copy(strName1, 0, bytes, size - iExtLen, iExtLen);
            IntPtr buf = Marshal.AllocHGlobal(size);
            Marshal.Copy(bytes, 0, buf, size);

            int r = SendIntptrMessageToOmap(OMAP_API_CMD_SRH_OBJ, buf, size);
            Marshal.FreeHGlobal(buf);
            return r;

            
        }

        public int SetOmapButton(int iAdd,byte[]strTip)
        {
            // 0: 删除, 1: 添加, -1: 查询
            tagOMapBtnInfo pBtnInfo = new tagOMapBtnInfo();
            int iExtLen = Marshal.SizeOf(pBtnInfo);
            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(iExtLen);
            pBtnInfo.iAdd = iAdd;
            int size = Marshal.SizeOf(pOoh) + iExtLen;
            byte[] bytes = new byte[size];
            if(strTip!=null)
            {
                Array.Copy(strTip, pBtnInfo.strTip, iExtLen);
            }
            IntPtr buffer1 = Marshal.AllocHGlobal(Marshal.SizeOf(pOoh));
            Marshal.StructureToPtr(pOoh, buffer1, true);
            Marshal.Copy(buffer1, bytes, 0, Marshal.SizeOf(pOoh));
            Marshal.FreeHGlobal(buffer1);

            IntPtr buffer2 = Marshal.AllocHGlobal(Marshal.SizeOf(pBtnInfo));
            Marshal.StructureToPtr(pBtnInfo, buffer1, true);
            Marshal.Copy(buffer2, bytes, size-iExtLen, Marshal.SizeOf(pBtnInfo));
            Marshal.FreeHGlobal(buffer2);

            IntPtr buf = Marshal.AllocHGlobal(size);
            Marshal.Copy(bytes, 0, buf, size);

            int r = SendIntptrMessageToOmap(OMAP_API_CMD_SET_BTN, buf, size);
            Marshal.FreeHGlobal(buf);

            return r;

        }

        public int GetOmapStatusInfo()
        {
            // 两种方式均可判断返回值
            // 1. 函数返回值, 2. 命令返回值
            Int64 lResult = 0;
            SendMessageToOmap(OMAP_API_CMD_GET_STATUS_INFO, null, 0, lResult);

            // 判断方式
            // int iLv = GET_OMAP_API_STATUE_LV(r);
            // bool bLoad = GET_OMAP_API_STATUE_LOAD(r)

            return (int)lResult;
        }

        public int GetOmapMapData(double x_lng1, double y_lat1, double x_lng2, double y_lat2, Int64 iMaxPixel, int iMaxLevel)
        {
            tagOmapGetMap pGet = new tagOmapGetMap();
            int iExtLen = Marshal.SizeOf(pGet);
            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(iExtLen);
            int size = Marshal.SizeOf(pOoh) + iExtLen;
            byte[] bytes = new byte[size];
            pGet.x_lng1 = x_lng1;
            pGet.y_lat1 = y_lat1;
            pGet.x_lng2 = x_lng2;
            pGet.y_lat2 = y_lat2;
            pGet.y_lat2 = y_lat2;
            pGet.bRealLl = 2;
            pGet.iMaxPixel = iMaxPixel;
            pGet.iMaxLevel = iMaxLevel;

            IntPtr buffer1 = Marshal.AllocHGlobal(Marshal.SizeOf(pOoh));
            Marshal.StructureToPtr(pOoh, buffer1, true);
            Marshal.Copy(buffer1, bytes, 0, Marshal.SizeOf(pOoh));
            Marshal.FreeHGlobal(buffer1);

            IntPtr buffer2 = Marshal.AllocHGlobal(Marshal.SizeOf(pGet));
            Marshal.StructureToPtr(pGet, buffer1, true);
            Marshal.Copy(buffer2, bytes, size - iExtLen, Marshal.SizeOf(pGet));
            Marshal.FreeHGlobal(buffer2);

            IntPtr buf = Marshal.AllocHGlobal(size);
            Marshal.Copy(bytes, 0, buf, size);

            int r = SendIntptrMessageToOmap(OMAP_API_CMD_GET_MAP_DATA, buf, size);
            Marshal.FreeHGlobal(buf);

            return r;

        }

        public int SetSysCoorPoint(int iCoorType, tagOApiRelatePointV1 []pPoint, int nPoint)
        {
            // iCoorType, 0: 奥维平面坐标, 3, 关联点, 4: 简化参数
            // 0与4只有第1个关联点有效, 3支持多个关联点

            // 命令返回值: OMAP_RET_SYS_COOR_XXX
            if (nPoint <= 0)
                return -1;

            int[] iValueList = new int[10];
            iValueList[0] = iCoorType;
            tagOApiRelatePointV1 Point = new tagOApiRelatePointV1();

            int iValueLen = Marshal.SizeOf(iValueList);
            int iPointLen = Marshal.SizeOf(Point) * nPoint;
            int iExtLen = iValueLen + iPointLen;
            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(iExtLen);
            int size = Marshal.SizeOf(pOoh) + iExtLen;
            byte[] bytes = new byte[size];

            IntPtr buffer1 = Marshal.AllocHGlobal(Marshal.SizeOf(pOoh));
            Marshal.StructureToPtr(pOoh, buffer1, true);
            Marshal.Copy(buffer1, bytes, 0, Marshal.SizeOf(pOoh));
            Marshal.FreeHGlobal(buffer1);

            byte[] biValueList = new byte[iValueLen];
           
            for (int i = 0; i < iValueLen;i++)
            {
                byte[] biValue = BitConverter.GetBytes(iValueList[i]);
                Array.Copy(biValue, 0, biValueList, i * sizeof(int), sizeof(int));
                
            }
            Array.Copy(biValueList, 0, bytes, size - iExtLen, iValueLen);

            byte[] bpPoint = new byte[iPointLen];
            for (int i = 0; i < nPoint; i++ )
            {
                byte[]bPoint = new byte[Marshal.SizeOf(pPoint)];
                IntPtr buffer2 = Marshal.AllocHGlobal(Marshal.SizeOf(pPoint));
                Marshal.StructureToPtr(pPoint, buffer2, true);
                Marshal.Copy(buffer2, bPoint, 0, Marshal.SizeOf(pPoint));
                Marshal.FreeHGlobal(buffer2);
                Array.Copy(bPoint, 0, bpPoint, i * iPointLen / nPoint, iPointLen / nPoint);
            }
            Array.Copy(bpPoint, 0, bytes, size - iPointLen, iPointLen);

            IntPtr buf = Marshal.AllocHGlobal(size);
            Marshal.Copy(bytes, 0, buf, size);

            int r = SendIntptrMessageToOmap(OMAP_API_CMD_SET_SYS_COOR_POINT, buf, size);
            Marshal.FreeHGlobal(buf);

            return r;
        }

        public void GetSysCoorInfo()
        {
            SendMessageToOmap(OMAP_API_CMD_GET_SYS_COOR_INFO, null, 0);
        }

       public tagOApiObjGroupV1 NewOmapGroup()
        {
            tagOApiObjGroupV1 pGroup = new tagOApiObjGroupV1();
            pGroup.bAutoLoad = 1;
            return pGroup;
        }

       public tagOApiMapSignV1 NewOmapSign()
        {
            tagOApiMapSignV1 pSign = new tagOApiMapSignV1();
            
            return pSign;
        }

       public tagOApiMapTrackV1 NewOmapTrack()
        {
            tagOApiMapTrackV1 pTrack = new tagOApiMapTrackV1();
            pTrack.mtd.iLineWidth = 3;
            pTrack.mtd.iLineAlpha = 50;
            pTrack.mtd.dwLineClr = (uint)Color.FromArgb(255, 0, 0).ToArgb();
            return pTrack;
        }

       public tagOApiMapShapeV1 NewOmapShape()
        {
            tagOApiMapShapeV1 pShape = new tagOApiMapShapeV1();
            pShape.iLineAlpha = 50;
            pShape.iAreaAlpha = 50;
            pShape.iLineWidth = 1;
            pShape.dwLineClr = (uint)Color.FromArgb(0, 0, 255).ToArgb();
            pShape.dwAreaClr = (uint)Color.FromArgb(0, 0, 255).ToArgb();
            return pShape;
        }

        public tagOApiMapDirectionsV1 NewOmapDir()
        {
            tagOApiMapDirectionsV1 pDir = new tagOApiMapDirectionsV1();
            pDir.dwLineClr = (uint)Color.FromArgb(255, 0, 0).ToArgb();
            pDir.iLineAlpha = 60;
            pDir.iLineWidth = 7;
            return pDir;

        }

        public static object BytesToStruct(byte[] bytes, Type type)
        {
            int size = Marshal.SizeOf(type);
            IntPtr buffer = Marshal.AllocHGlobal(size);
            try
            {
                Marshal.Copy(bytes, 0, buffer, size);
                return Marshal.PtrToStructure(buffer, type);
            }
            finally
            {
                Marshal.FreeHGlobal(buffer);
            }
        }





        public tagOApiObjGroupV1 GetOmapGroupFromBuf(byte[] pBuf, int nBuf)
        {
            tagOApiObjGroupV1 pGroup = NewOmapGroup();
            int size=Marshal.SizeOf(pGroup);
            if (nBuf != size)
            {
                return pGroup;
            }
            byte[] bytes = new byte[size];//tagOApiObjGroupV1大小为176
            Array.Copy(pBuf, 16, bytes, 0, size);//tagOApiObjectOptHdr大小为16
            pGroup = (tagOApiObjGroupV1)BytesToStruct(bytes, typeof(tagOApiObjGroupV1));
            return pGroup;
        }

        public tagOApiMapSignV1 GetOmapSignFromBuf(byte[] pBuf, int nBuf)
        {
            
            tagOApiMapSignV1 pSign = NewOmapSign();
            int size = Marshal.SizeOf(pSign);
            if (nBuf < size + 4)
                return pSign;
            int nComment = 0;
            byte[] intBuff = new byte[4];
            Array.Copy(pBuf, size+16, intBuff, 0, 4);
            nComment = BitConverter.ToInt32(intBuff, 0);
            if (nBuf != size + 4 + nComment)
                return pSign;

            byte[] bytes = new byte[size];
            Array.Copy(pBuf, 16, bytes, 0, size);//tagOApiObjectOptHdr大小为16
            pSign = (tagOApiMapSignV1)BytesToStruct(bytes, typeof(tagOApiMapSignV1));
            
            if(nComment>0)
            {
                byte[]pstrBuff = new byte[nComment];
                Array.Copy(pBuf, size + 20, pstrBuff, 0, nComment);//16+4 
                pSign.pstrComment = pstrBuff;
            }
            else
            {
                pSign.pstrComment = null;
            }
 
            return pSign;

        }
       public tagOApiMapTrackV1 GetOmapTrackFromBuf(byte[] pBuf, int nBuf)
        {

            tagOApiMapTrackV1 pTrack = NewOmapTrack();
            int size = Marshal.SizeOf(pTrack);
            int nComment = 0;
            byte[] intBuff = new byte[4];
            Array.Copy(pBuf, size + 16, intBuff, 0, 4);
            nComment = BitConverter.ToInt32(intBuff, 0);
            int iMtOffset = size + 4 + nComment;
            iMtOffset = OMAP_ALIGN_8_BYTE(iMtOffset);
            if (nBuf < iMtOffset)
                return pTrack;
            byte[] bytes = new byte[size];
            Array.Copy(pBuf, 16, bytes, 0, size);
            pTrack = (tagOApiMapTrackV1)BytesToStruct(bytes, typeof(tagOApiMapTrackV1));
           
            if (nComment > 0)
            {
                byte[] pstrBuff = new byte[nComment];
                Array.Copy(pBuf, size + 20, pstrBuff, 0, nComment);
                pTrack.pstrComment = pstrBuff;
            }
            else
                pTrack.pstrComment = null;
            int pontSize = Marshal.SizeOf(new tagOApiMapTrackPointV1());
           
           if(nBuf!=iMtOffset+pTrack.nMtp*pontSize)
           {
               return pTrack;
           }
           byte[] pMtp = new byte[pTrack.nMtp * pontSize];
           Array.Copy(pBuf, iMtOffset + 16, pMtp, 0, pTrack.nMtp * pontSize);
           tagOApiMapTrackPointV1 Mtp = (tagOApiMapTrackPointV1)BytesToStruct(pMtp, typeof(tagOApiMapTrackPointV1));

            return pTrack;
           



        }
      public  tagOApiMapShapeV1 GetOmapShapeFromBuf(byte[] pBuf, int nBuf)
        {
            
            tagOApiMapShapeV1 pShape = NewOmapShape();
            int size = Marshal.SizeOf(pShape);
            if (nBuf < size + 4)
                return pShape;
            int nComment = 0;
            byte[] intBuff = new byte[4];
            Array.Copy(pBuf, size + 16, intBuff, 0, 4);
            nComment = BitConverter.ToInt32(intBuff, 0);
            int iMtOffset = size + 4 + nComment;
            iMtOffset = OMAP_ALIGN_8_BYTE(iMtOffset);
            if (nBuf < iMtOffset)
                return pShape;
            byte[] bytes = new byte[size];
            Array.Copy(pBuf, 16, bytes, 0, size);
            pShape = (tagOApiMapShapeV1)BytesToStruct(bytes, typeof(tagOApiMapShapeV1));

            if (nComment > 0)
            {
                byte[] pstrBuff = new byte[nComment];
                Array.Copy(pBuf, size + 20, pstrBuff, 0, nComment);
                pShape.pstrComment = pstrBuff;
            }
            else
                pShape.pstrComment = null;
           int pontSize = Marshal.SizeOf(new tagOApiMapTrackPointV1());
          if(nBuf!=iMtOffset+pShape.nMtp*pontSize)
          {
              return pShape;
          }
          byte[] pMtp = new byte[pShape.nMtp * pontSize];
          Array.Copy(pBuf, iMtOffset + 16, pMtp, 0, pShape.nMtp * pontSize);
          tagOApiMapTrackPointV1 Mtp = (tagOApiMapTrackPointV1)BytesToStruct(pMtp, typeof(tagOApiMapTrackPointV1));
            return pShape;
        }
       public tagOApiMapDirectionsV1 GetOmapDirFromBuf(byte[] pBuf, int nBuf)
        {
           
            tagOApiMapDirectionsV1 pDir = NewOmapDir();
            
            int size = Marshal.SizeOf(pDir);
            if (nBuf < size + 4)
                return pDir;
            int nComment = 0;
            byte[] intBuff = new byte[4];
            Array.Copy(pBuf, size + 16, intBuff, 0, 4);//sizeof(tagOApiObjectOptHdr)=16
            nComment = BitConverter.ToInt32(intBuff, 0);
            int iUnitOffset = size + 4 + nComment;
            iUnitOffset = OMAP_ALIGN_8_BYTE(iUnitOffset);
            if (nBuf < iUnitOffset)
                return pDir;
            byte[] bytes = new byte[size];
            Array.Copy(pBuf, 16, bytes, 0, size);//sizeof(tagOApiObjectOptHdr)=16
            pDir = (tagOApiMapDirectionsV1)BytesToStruct(bytes, typeof(tagOApiMapDirectionsV1));
            if (nComment > 0)
            {
                byte[] pstrBuff = new byte[nComment];
                Array.Copy(pBuf, size + 20, pstrBuff, 0, nComment);//sizeof(tagOApiObjectOptHdr)+4=16+4=20
                pDir.pstrComment = pstrBuff;
            }
            else
                pDir.pstrComment = null;
            //if (nBuf < iUnitOffset + pDir.nUnit * Marshal.SizeOf(new tagOApiMapDirectionsUnitV1()))
            //{
            //    return pDir;
            //}
            int iLlOffset = iUnitOffset + pDir.nUnit * Marshal.SizeOf(new tagOApiMapDirectionsUnitV1());

            
           
            return pDir;
        }

        //idObj:对象ID，为0时则表示要添加，此时需要设置idParent
        //idParent:当指定了idObj的值时，此项值无用，当idObj=0时，指示要插入的父节点的ID，此时idParent=0表示插入到根节点下
        //iPosition:当指定了idObj的值时，此项值无用，当idObj=0时，指示要插入到父节点下的哪个位置，0表示最后
        public int SetOmapObject(uint idObj, tagOApiObjGroupV1 pGroup, uint idParent, int iPosition)
        {
            if (idObj == 0 && idParent == 0)
            {
                //奥维地图收藏夹根节点ID为1
                idParent = 1;
            }
            
            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(0);
            pOoh.idObj = idObj;
            pOoh.idParent = idParent;
            pOoh.iType = OMAP_OBJ_TYPE_GROUP;
            pOoh.iVersion = OMAP_WIN_API_VERSION;
            pOoh.ret = iPosition;

            int size = Marshal.SizeOf(pOoh) + Marshal.SizeOf(pGroup);
            byte[] bytess = new byte[size];
          

            IntPtr buffer1 = Marshal.AllocHGlobal(Marshal.SizeOf(pOoh));
            Marshal.StructureToPtr(pOoh, buffer1, true);
            Marshal.Copy(buffer1, bytess, 0, Marshal.SizeOf(pOoh));
            Marshal.FreeHGlobal(buffer1);

            IntPtr buffer2 = Marshal.AllocHGlobal(Marshal.SizeOf(pGroup));
            Marshal.StructureToPtr(pGroup, buffer2, true);
            Marshal.Copy(buffer2, bytess, Marshal.SizeOf(pOoh), Marshal.SizeOf(pGroup));
            Marshal.FreeHGlobal(buffer2);

            IntPtr buf = Marshal.AllocHGlobal(size);
            Marshal.Copy(bytess, 0, buf, size);

            int r = SendIntptrMessageToOmap(OMAP_API_CMD_SET_OBJ,buf, size);
            Marshal.FreeHGlobal(buf);
            return r;
        }

        //设置标签对象
        public int SetOmapObject(uint idObj, tagOApiMapSignV1 pSign, uint idParent, int iPosition)
        {
            if (idObj == 0 && idParent == 0)
                idParent = 1;

            int iExtLen = Marshal.SizeOf(pSign);
            
            int nComment = 0;
            if (pSign.pstrComment != null)
            {
                nComment = (int)(pSign.pstrComment).Length;
            }
            iExtLen += nComment + 4;
            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(iExtLen);
            int size=Marshal.SizeOf(pOoh)+iExtLen;
            pOoh.idObj = idObj;
            pOoh.idParent = idParent;
            pOoh.iType = OMAP_OBJ_TYPE_SIGN;
            pOoh.iVersion = OMAP_WIN_API_VERSION;
            pOoh.ret = iPosition;
           
            byte[] bytess = new byte[size];
            byte [] intBuff = BitConverter.GetBytes(nComment);

            IntPtr buffer1 = Marshal.AllocHGlobal(Marshal.SizeOf(pOoh));
            Marshal.StructureToPtr(pOoh, buffer1, true);
            Marshal.Copy(buffer1, bytess, 0, Marshal.SizeOf(pOoh));
            Marshal.FreeHGlobal(buffer1);

            IntPtr buffer2 = Marshal.AllocHGlobal(Marshal.SizeOf(pSign));
            Marshal.StructureToPtr(pSign, buffer2, true);
            Marshal.Copy(buffer2, bytess, Marshal.SizeOf(pOoh), Marshal.SizeOf(pSign));
            Marshal.FreeHGlobal(buffer2);

            Array.Copy(intBuff, 0, bytess, size - nComment - 4, 4);
            if (nComment != 0)
                Array.Copy(pSign.pstrComment, 0, bytess, size - nComment, nComment);
            IntPtr buf = Marshal.AllocHGlobal(size);
            Marshal.Copy(bytess, 0, buf, size);

            int r = SendIntptrMessageToOmap(OMAP_API_CMD_SET_OBJ, buf,size);
            Marshal.FreeHGlobal(buf);
            return r;
        }

        //设置轨迹对象
        public int SetOmapObject(uint idObj, tagOApiMapTrackV1 pTrack, uint idParent, int iPosition)
        {
            if (idObj == 0 && idParent == 0)
                idParent = 1;
            
            int iExtLen = Marshal.SizeOf(pTrack);
            
            tagOApiMapTrackPointV1 pT = new tagOApiMapTrackPointV1();
            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(0);
            
            int nComment = 0;
            if (pTrack.pstrComment != null)
            {
                nComment = (int)(pTrack.pstrComment).Length;
            }
            int tag = iExtLen + nComment + 4;
            iExtLen = OMAP_ALIGN_8_BYTE(tag);
            tag = iExtLen - tag;
            
            int size = Marshal.SizeOf(pOoh) + iExtLen + pTrack.nMtp * Marshal.SizeOf(pT);
            
            byte[]bytess = new byte[size];
            pOoh.idObj = idObj;
            pOoh.idParent = idParent;
            pOoh.iType = OMAP_OBJ_TYPE_TRACK;
            pOoh.iVersion = OMAP_WIN_API_VERSION;
            pOoh.ret = iPosition;

            byte[] intBuff = BitConverter.GetBytes(nComment);

            IntPtr buffer1 = Marshal.AllocHGlobal(Marshal.SizeOf(pOoh));
            Marshal.StructureToPtr(pOoh, buffer1, true);
            Marshal.Copy(buffer1, bytess, 0, Marshal.SizeOf(pOoh));
            Marshal.FreeHGlobal(buffer1);

            IntPtr buffer2 = Marshal.AllocHGlobal(Marshal.SizeOf(pTrack));
            Marshal.StructureToPtr(pTrack, buffer2, true);
            Marshal.Copy(buffer2, bytess, Marshal.SizeOf(pOoh), Marshal.SizeOf(pTrack));
            Marshal.FreeHGlobal(buffer2);

            Array.Copy(intBuff, 0, bytess, size - pTrack.nMtp * Marshal.SizeOf(pT) - nComment -4-tag, 4);
            if (pTrack.pstrComment != null)
                Array.Copy(pTrack.pstrComment, 0, bytess, size- pTrack.nMtp * Marshal.SizeOf(pT) - nComment-tag, nComment);
            tagOApiMapTrackV2 pTrack2 = new tagOApiMapTrackV2();
            pTrack2.pMtp = new tagOApiMapTrackPointV1[pTrack.nMtp];
            for (int i = 0; i < pTrack.nMtp; i++)
            {
                pTrack2.pMtp[i].lat = 40.1122 + i * 0.001;
                pTrack2.pMtp[i].lng = 116.2223 + i * (i * 0.1) * 0.002;
            }
            byte[] pbytes = new byte[Marshal.SizeOf(pT) * pTrack.nMtp];
            for (int i = 0; i < pTrack.nMtp; i++)
            {
                IntPtr buffer = Marshal.AllocHGlobal(Marshal.SizeOf(pT));
                Marshal.StructureToPtr(pTrack2.pMtp[i], buffer, true);
                byte[] bytes = new byte[Marshal.SizeOf(pT)];
                Marshal.Copy(buffer, bytes, 0, Marshal.SizeOf(pT));

                Array.Copy(bytes, 0, pbytes, i * Marshal.SizeOf(pT), Marshal.SizeOf(pT));
                Marshal.FreeHGlobal(buffer);

            }
            Array.Copy(pbytes, 0, bytess, size - pTrack.nMtp * Marshal.SizeOf(pT), pTrack.nMtp * Marshal.SizeOf(pT));
            IntPtr buf = Marshal.AllocHGlobal(size);
            Marshal.Copy(bytess, 0, buf, size);

            
            int r = SendIntptrMessageToOmap(OMAP_API_CMD_SET_OBJ,buf,size);
            Marshal.FreeHGlobal(buf);
            return r;

        }

        //设置图形对象
        public int SetOmapObject(uint idObj, tagOApiMapShapeV1 pShape, uint idParent, int iPosition)
        {
            if (idObj == 0 && idParent == 0)
                idParent = 1;
            int iExtLen = Marshal.SizeOf(pShape);
            
            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(0);
            tagOApiMapTrackPointV1 pT = new tagOApiMapTrackPointV1();
            
            int nComment = 0;
            if (pShape.pstrComment != null)
            {
                nComment = (int)(pShape.pstrComment).Length;
            }
            int tag = iExtLen + nComment + 4;
            iExtLen = OMAP_ALIGN_8_BYTE(tag);
            tag = iExtLen - tag;//转换差
            
            
            int size = Marshal.SizeOf(pOoh) + iExtLen + pShape.nMtp * Marshal.SizeOf(pT);
            int size1 = iExtLen;
            int size2 =pShape.nMtp * Marshal.SizeOf(pT);
            
            pOoh.idObj = idObj;
            pOoh.idParent = idParent;
            pOoh.iType = OMAP_OBJ_TYPE_SHAPE;
            pOoh.iVersion = OMAP_WIN_API_VERSION;
            pOoh.ret = iPosition;

            byte[] intBuff = BitConverter.GetBytes(nComment);
            byte[] bytess = new byte[size];

            IntPtr buffer1 = Marshal.AllocHGlobal(Marshal.SizeOf(pOoh));
            Marshal.StructureToPtr(pOoh, buffer1, true);
            Marshal.Copy(buffer1, bytess, 0, Marshal.SizeOf(pOoh));
            Marshal.FreeHGlobal(buffer1);

            IntPtr buffer2 = Marshal.AllocHGlobal(Marshal.SizeOf(pShape));
            Marshal.StructureToPtr(pShape, buffer2, true);
            Marshal.Copy(buffer2, bytess, Marshal.SizeOf(pOoh), Marshal.SizeOf(pShape));
            Marshal.FreeHGlobal(buffer2);

            Array.Copy(intBuff, 0, bytess, size - pShape.nMtp*Marshal.SizeOf(pT)-nComment - 4-tag, 4);
            if (pShape.pstrComment != null)
                Array.Copy(pShape.pstrComment, 0, bytess, size -pShape.nMtp*Marshal.SizeOf(pT)-nComment-tag, nComment);

            tagOApiMapShapeV2 pShape2 = new tagOApiMapShapeV2();
            pShape2.pMtp= new tagOApiMapTrackPointV1[pShape.nMtp];
            for (int i = 0; i < pShape.nMtp; i++)
            {
                pShape2.pMtp[i].lat = 40.1122 + i * 0.001;
                pShape2.pMtp[i].lng = 116.2223 + i * (i * 0.1) * 0.002;
            }
            byte[] pbytes = new byte[Marshal.SizeOf(pT) * pShape.nMtp];
            for (int i = 0; i < pShape.nMtp; i++)
            {
                IntPtr buffer = Marshal.AllocHGlobal(Marshal.SizeOf(pT));
                Marshal.StructureToPtr(pShape2.pMtp[i], buffer, true);
                byte[] bytes = new byte[Marshal.SizeOf(pT)];
                Marshal.Copy(buffer, bytes, 0, Marshal.SizeOf(pT));

                Array.Copy(bytes, 0, pbytes, i * Marshal.SizeOf(pT), Marshal.SizeOf(pT));
                Marshal.FreeHGlobal(buffer);

            }
            Array.Copy(pbytes, 0, bytess, size - pShape.nMtp * Marshal.SizeOf(pT), pShape.nMtp * Marshal.SizeOf(pT));

            IntPtr buf = Marshal.AllocHGlobal(size);
            Marshal.Copy(bytess, 0, buf, size);

            int r = SendIntptrMessageToOmap(OMAP_API_CMD_SET_OBJ, buf, size);
            Marshal.FreeHGlobal(buf);
            return r;
        }

        //设置图形对象
        public int SetOmapObject(uint idObj, tagOApiMapDirectionsV1 pDir, uint idParent, int iPosition)
        {
            if (idObj == 0 && idParent == 0)
                idParent = 1;

            int iExtLen = Marshal.SizeOf(pDir);
            int nComment=0;

            tagOApiObjectOptHdr pOoh = OApiNewOptHdr(0);
            pOoh.idObj = idObj;
            pOoh.idParent = idParent;
            pOoh.iType = OMAP_OBJ_TYPE_DIR;
            pOoh.iVersion = OMAP_WIN_API_VERSION;
            pOoh.ret = iPosition;
            tagOApiLatLngV1 tL = new tagOApiLatLngV1();
            tagOApiMapDirectionsUnitV1 pDU = new tagOApiMapDirectionsUnitV1();
            tagOApiMapDirectionsV2 pDir2 = new tagOApiMapDirectionsV2();
            tagOApiMapDirectionsUnitV2 pDU2 = new tagOApiMapDirectionsUnitV2();
            Random rdm = new Random();
            pDir2.pUnit = new tagOApiMapDirectionsUnitV1[pDir.nUnit];
           
            double lat = 40.1;
            double lng = 116.1;
            pDir.dirSrh.iDirMode = 0;
            pDir.dirSrh.mpStart.lat = 40.099;
            pDir.dirSrh.mpStart.lng = 116.099;
            pDU2.llList = new tagOApiLatLngV1[20 * 10];
            for (int i = 0; i < pDir.nUnit; i++)
            {
                pDir2.pUnit[i].strTitle = Encoding.Default.GetBytes(("step" + (i + 1)).Trim().PadRight(128, '\0'));
                if (i == 0)
                {   
                    byte []stra = new byte[128];
                     stra=Encoding.Default.GetBytes(("substep1").Trim().PadRight(128, '\0'));
                    byte[]strb= new byte[128];
                    strb = Encoding.Default.GetBytes(("substep2").Trim().PadRight(128, '\0'));
                    pDir2.pUnit[i].strSubTitle = new byte[10,128];
                    for (int l = 0; l < 2; l++)
                    {
                        for(int m = 0 ; m<128;m++)
                        {
                            if (l == 0)
                                pDir2.pUnit[i].strSubTitle[l, m] = stra[m];
                            else
                                pDir2.pUnit[i].strSubTitle[l, m] = strb[m];
                        }
                    }
                        pDir2.pUnit[i].nSubCount = 2;
                }
                pDir2.pUnit[i].nLl = 20;
                
                int a = rdm.Next() % 10 + 1;
                int b = rdm.Next() % 10 + 1;
                
                for (int j = 0; j < pDir2.pUnit[i].nLl; j++)
                {
                    if (j > 0)
                    {
                        lat += a / 1000.0;
                        lng += b / 1000.0;
                    }
                    
                    pDU2.llList[20*i+j].lat = lat;
                    pDU2.llList[20*i+j].lng = lng;
                    
                }
            }
            

            pDir.dirSrh.mpEnd.lat = lat;
            pDir.dirSrh.mpEnd.lng = lng;


            if(pDir.pstrComment!=null)
                nComment = (int)(pDir.pstrComment).Length;
            int tag = iExtLen + nComment + 4;
            iExtLen = OMAP_ALIGN_8_BYTE(tag);
            tag = iExtLen - tag;
            int nLl = 0;
            for(int i = 0 ; i <pDir.nUnit;i++)
            {
                nLl += pDir2.pUnit[i].nLl;
            }
            int size = Marshal.SizeOf(pOoh) + iExtLen+pDir.nUnit*Marshal.SizeOf(pDU)+nLl*Marshal.SizeOf(tL);
            byte[] intBuff = BitConverter.GetBytes(nComment);
            byte[] bytess = new byte[size];

            IntPtr buffer1 = Marshal.AllocHGlobal(Marshal.SizeOf(pOoh));
            Marshal.StructureToPtr(pOoh, buffer1, true);
            Marshal.Copy(buffer1, bytess, 0, Marshal.SizeOf(pOoh));
            Marshal.FreeHGlobal(buffer1);

            IntPtr buffer2 = Marshal.AllocHGlobal(Marshal.SizeOf(pDir));
            Marshal.StructureToPtr(pDir, buffer2, true);
            Marshal.Copy(buffer2, bytess, Marshal.SizeOf(pOoh), Marshal.SizeOf(pDir));
            Marshal.FreeHGlobal(buffer2);

            Array.Copy(intBuff, 0, bytess, size -pDir.nUnit*Marshal.SizeOf(pDU)-nLl*Marshal.SizeOf(tL)- nComment - 4-tag, 4);
            if (pDir.pstrComment != null)
                Array.Copy(pDir.pstrComment, 0, bytess, size - nComment - pDir.nUnit * Marshal.SizeOf(pDU) - nLl * Marshal.SizeOf(tL)-tag, nComment);

            byte[] pbytes = new byte[Marshal.SizeOf(pDU) * pDir.nUnit];
            for (int i = 0; i < pDir.nUnit; i++)
            {
                IntPtr buffer3 = Marshal.AllocHGlobal(Marshal.SizeOf(pDU));
                Marshal.StructureToPtr(pDir2.pUnit[i], buffer3, true);
                byte[] bytes = new byte[Marshal.SizeOf(pDU)];
                Marshal.Copy(buffer3, bytes, 0, Marshal.SizeOf(pDU));
                Array.Copy(bytes, 0, pbytes, i * Marshal.SizeOf(pDU), Marshal.SizeOf(pDU));
                Marshal.FreeHGlobal(buffer3);

            }
            Array.Copy(pbytes, 0, bytess, size - pDir.nUnit * Marshal.SizeOf(pDU) - nLl * Marshal.SizeOf(tL), pDir.nUnit * Marshal.SizeOf(pDU));

            byte[] pbytess = new byte[Marshal.SizeOf(tL)*nLl];
            for (int i = 0; i < nLl; i++)
            {
                IntPtr buffer4 = Marshal.AllocHGlobal(Marshal.SizeOf(tL));
                Marshal.StructureToPtr(pDU2.llList[i], buffer4, true);
                byte[] bytes = new byte[Marshal.SizeOf(tL)];
                Marshal.Copy(buffer4, bytes, 0, Marshal.SizeOf(tL));
                Array.Copy(bytes, 0, pbytess, i * Marshal.SizeOf(tL), Marshal.SizeOf(tL));
                Marshal.FreeHGlobal(buffer4);

            }
            Array.Copy(pbytess, 0, bytess, size - nLl * Marshal.SizeOf(tL), nLl * Marshal.SizeOf(tL));

            IntPtr buf = Marshal.AllocHGlobal(size);
            Marshal.Copy(bytess, 0, buf, size);
    
             int r = SendIntptrMessageToOmap(OMAP_API_CMD_SET_OBJ, buf, size);
            Marshal.FreeHGlobal(buf);
            return r;
           
        }
        public int SetOmapObject(uint idObj, int iObjType, object pObj, uint idParent, int iPosition)
        {
            if (iObjType == OMAP_OBJ_TYPE_GROUP)
                return SetOmapObject(idObj, new tagOApiObjGroupV1(), idParent, iPosition);
            else if (iObjType == OMAP_OBJ_TYPE_SIGN)
                return SetOmapObject(idObj, new tagOApiMapSignV1(), idParent, iPosition);
            else if (iObjType == OMAP_OBJ_TYPE_TRACK)
                return SetOmapObject(idObj, new tagOApiMapTrackV1(), idParent, iPosition);
            else if (iObjType == OMAP_OBJ_TYPE_SHAPE)
                return SetOmapObject(idObj, new tagOApiMapShapeV1(), idParent, iPosition);
            else if (iObjType == OMAP_OBJ_TYPE_DIR)
                return SetOmapObject(idObj, new tagOApiMapDirectionsV1(), idParent, iPosition);
            else
                return 0;
        }

        //pData类型为struct数组
        //nData为数组大小
        //size为数组个数
        public int SendMessagesToOmap(int iCmdId, OmapInterface.OMapApiTest.tagOPhotoMapPic[] pData, int nData, int size)
        {
            IntPtr hwnd = FindWindow("omapWin", null);


            if (hwnd == IntPtr.Zero)
            {
                M_iAppID = 0;
                M_iOmapVer = 0;
                return OMAP_API_ERR_WND;
            }

            if (M_iAppID == 0)
                RegisterToOmap();
            if (M_iAppID == 0)
                return OMAP_API_ERR_REGISTER;

            if (!CmdCheck(iCmdId))
                return OMAP_API_ERR_VER;



            COPYDATASTRUCT cd = new COPYDATASTRUCT();

            if (pData != null)
            {
                int len = nData/size;//每个对象大小
                int iMax = size;//对象数量
                byte[] bytess = new byte[nData];

                //循环取得数组内容 
                for (int i = 0; i < iMax; i++)
                { 
                    IntPtr buffer = Marshal.AllocHGlobal(len);//分配单个对象大小的内存空间
                    Marshal.StructureToPtr(pData[i], buffer, true);//将单个struct对象转换为Intptr类型
                    byte[] bytes = new byte[len];
                    Marshal.Copy(buffer, bytes, 0, len);//将数据拷贝到bytes数组中

                    Array.Copy(bytes, 0, bytess, i * len, len);//将数据按顺序拷贝到大数组中
                    Marshal.FreeHGlobal(buffer);

                }
                IntPtr structPtr = Marshal.AllocHGlobal(nData);
                //将bytess数组拷贝到分配好的内存空间
                Marshal.Copy(bytess, 0, structPtr, nData);
                cd.lpData = structPtr;



            }
            else
                cd.lpData = IntPtr.Zero;

            cd.dwData = (IntPtr)((M_iAppID << 16) | iCmdId);
            cd.cbData = nData;


            int r = SendMessage(hwnd, WM_COPYDATA, OMAP_WIN_API_FLAG, ref cd);
            int ret = 0;
            if (IS_OMAP_API_INTERRUPT_ERR(r))
            {
                ret = (int)r;
                r = 0;
            }
            if (r < 0)
            {
                M_iAppID = 0;
                M_iOmapVer = 0;
                RegisterToOmap();
                if (M_iAppID == 0)
                    return OMAP_API_ERR_REGISTER;
                if (!CmdCheck(iCmdId))
                    return OMAP_API_ERR_VER;

                r = SendMessage(hwnd, WM_COPYDATA, OMAP_WIN_API_FLAG, ref cd);
                if (r == OMAP_API_ERR_NOT_VIP || r == OMAP_API_ERR_DEAL)
                    ret = (int)r;
            }
            return ret;
        }

        //pData类型为pData
        public int SendIntptrMessageToOmap(int iCmdId, IntPtr pData, int nData)
        {
            IntPtr hwnd = FindWindow("omapWin", null);
            if (hwnd == IntPtr.Zero)
            {
                M_iAppID = 0;
                M_iOmapVer = 0;
                return OMAP_API_ERR_WND;
            }

            if (M_iAppID == 0)
                RegisterToOmap();
            if (M_iAppID == 0)
                return OMAP_API_ERR_REGISTER;

            if (!CmdCheck(iCmdId))
                return OMAP_API_ERR_VER;

            COPYDATASTRUCT cd = new COPYDATASTRUCT();

            if (pData != null)
            {

                cd.lpData = pData;

            }
            else
                cd.lpData = IntPtr.Zero;

            cd.dwData = (IntPtr)((M_iAppID << 16) | iCmdId);
            cd.cbData = nData;


            int r = SendMessage(hwnd, WM_COPYDATA, OMAP_WIN_API_FLAG, ref cd);
            int ret = 0;
            if (r == OMAP_API_ERR_NOT_VIP || r == OMAP_API_ERR_DEAL)
            {
                ret = (int)r;
                r = 0;
            }
            if (r < 0)
            {
                M_iAppID = 0;
                M_iOmapVer = 0;
                RegisterToOmap();
                if (M_iAppID == 0)
                    return OMAP_API_ERR_REGISTER;
                if (!CmdCheck(iCmdId))
                    return OMAP_API_ERR_VER;

                r = SendMessage(hwnd, WM_COPYDATA, OMAP_WIN_API_FLAG, ref cd);
                if (IS_OMAP_API_INTERRUPT_ERR(r))
                    ret = (int)r;
            }
            return ret;
        }
    }
}

