﻿using ChangeClassName;
using OmapInterface;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Microsoft.Win32;
using System.Text.RegularExpressions;
namespace OmapInterface
{
    public partial class OMapApiTest : Form
    {

        //经纬度
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOmapLatlng
        {
            public double lat;
            public double lng;
            public byte bReal;//是否真实经纬度
        }

        /*
地图位置
iMapID 地图id 
100文件夹：小字体谷歌地图下载文件夹
130文件夹：大字体谷歌地图下载文件夹

101文件夹：谷歌卫星图下载文件夹
160文件夹：小字体谷歌路网图下载文件夹
161文件夹：大字体谷歌路网图下载文件夹

102文件夹：小字体谷歌地形图下载文件夹
132文件夹：大字体谷歌地形图下载文件夹

103文件夹：bing卫星图下载文件夹

104文件夹：OpenCycle等高线图下载文件夹

105文件夹：小字体百度地图下载文件夹
135文件夹：大字体百度地图下载文件夹

106文件夹：小字体搜狗地图下载文件夹
136文件夹：大字体搜狗地图下载文件夹

200-1000文件夹：自定义地图下载文件夹（以地图ID命名）
*/
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOmapLocation
        {
            public tagOmapLatlng ll;
            public int iMapID;//地图类型ID
            public int iMapLevel;//地图级别
        }

        [StructLayout(LayoutKind.Sequential)]
        struct tagOmapLocationExt
        {
            tagOmapLocation ol;
            byte bActive;
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            uint[] ret;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct tagOPhotoMapPic
        {
            public Int64 idPic;//照片id
            public uint tmPhoto;//照片拍摄时间
            public double lat;//维度
            public double lng;//经度
            public int iAction;//ACTION_MOUSE_MOVE 1  ACTION_MOUSE_CLICK 2
            public int iTmp;//备用
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct tagOmapGeoDecode
        {
            public tagOmapLatlng oll;
            public int nLevel;//地图解析的层级  如 省市区3级、省市县3级、市区2级

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 1024)]
            public byte[] strArea;
        }

        [StructLayout(LayoutKind.Sequential)]
        struct tagOmapGetMap
        {
            public double x_lng1;
            public double y_lat1;
            public double x_lng2;
            public double y_lat2;
            public byte bRealLl;

            public Int64 iMaxPixel;
            public int iMaxLevel;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
            public int[] ret;
        }
        [StructLayout(LayoutKind.Sequential)]
        struct tagOMapBtnInfo
        {
            public int ret0;
            public int iAdd;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 256)]
            public char[] strTip;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
            public int[] ret1;
        }

        //存放收藏夹对象的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiObjectOptHdr
        {
            public ushort iVersion;//奥维版本
            public byte iType;//对象类型：文件夹、标签、轨迹、图形、路线
            //public byte bRet;//备用
            public byte bLlType;//坐标类型
            public uint idParent;//收藏夹对象的父节点的id 0表示该对象为根节点
            public uint idObj;//收藏夹对象的id
            public int ret;//节点所在位置
        }

        [StructLayout(LayoutKind.Sequential)]
        //收藏夹对象列表
        public struct tagOApiItemListV1
        {
            public uint idObj;//对象id
            public int iType;//对象类型
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称
        }
        [StructLayout(LayoutKind.Sequential)]

        public struct tagOApiObjGroupV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称

            public int nChild;//下一级子项的个数
            public int nAllChild;	//所有子项及其下属的总个数，未加载时该值也是一样
            public byte bLoadOk;	//是否加载成功

            public byte bSaveMerge;//存盘时pChild的内容是否合并存储，合并存储可大大加快载入时间，但使修改时存盘时间下降
            public byte bGroup;	//是否组合，不可展开
            public byte bAutoLoad;	//是否自动加载
            public byte iShowLevel;//是否隐藏
            public byte iShowLevelMax;//显示级别
            public byte bCrypt;	//是否加密, 如果设置了加密则自动加载将自动失效
            public byte bReadOnly;	//是否只读, 0: 不锁定, 1: 不带密码锁定, 2: 带密码锁定
            public byte bNotHotId;	//是否不响应鼠标事件
            public byte bRelate;	//是否是关联对象（目前用于标签与轨迹关联）
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] pwd;//设置的密码
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }

        //表示标签的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapSignV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] pstrComment;//标签备注

            public double lat;
            public double lng;
            public byte bRealLl;
            public int iAltitude;//海拔
            public int iTime;//生成时间
            public byte bEditMode;//是否可编辑
            public byte iOverlayIdx;//叠放层级
            public byte iSignAlignFlag;//标签图标对齐标志，0为默认下中对齐，1为正中对齐
            public int iSignPic;		//0:no picture,>=1 has sign picture
            public uint dwSignClr;
            public byte iPicScale;	//0:defalut,>=1 32*iPicScale/10
            public byte iTxtType;	//0:not show txt,1:show txt ,2:show text with border, 3: custom txt
            public byte iShowLevel;//标签显示级别
            public byte iShowLevelMax;	//show between iShowLevel-iShowLevelMax
            //自定义字体的信息
            tagOApiMapSignExtInfo el;
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapSignExtInfo
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strFontName;//对象名称
            public byte bFontZoomWithMap;
            public byte bFontWithBox;
            public byte iFontAlpha;
            public byte bFontEffect;
            public byte bFontBkStyle;
            public byte nFontBindLevel;
            public byte nFontMinLevel;
            public byte nFontMaxLevel;
            public int iFontSize;
            public uint dwFontClr;
            public uint dwFontBkClr;
            public float fFontRotateAngle;
            public byte bNoHotFontEvent;

            public Int64 idExt;
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.I8)]
            public Int64[] idExtBak;
        }
        //
        //struct tagOApiMapSignAttachmentV1{
        //	INT64 idAtta;
        //	union{
        //		IntPtr pData;
        //		double dAlign;
        //	};
        //	int nDataLen;
        //	unsigned int tCreate;
        //	unsigned int tModify;
        //	int nReference;
        //	char strName[MAX_API_NAME_LEN];
        //	char strExtTypeName[10];
        //	byte bNeedSaveData;
        //	byte bChange;
        //
        //	//如果是共享属性，则修改时会遍历标签，将所有关联附件都做更改
        //	byte bShare;
        //}

        //轨迹上的点的信息
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapTrackPointV1
        {
            public double lat;
            public double lng;
            public int time;//轨迹点的时间
            public int iAltitude;		// iAltitude >> 16 == 1 表示该点为新子图形(新子轨迹)的起始点即前一个点间断

            //扩展格式，用于CAD
            public double dCadBulge;
            public int iCadRet;


            public double dd;

            struct tagCadLwpLineWidth
            {
                public float fWidStart;
                public float fWidEnd;
            }

        }


        //表示轨迹的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapTrackV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] pstrComment;//标签备注
            //public tagOApiMapTrackPointV1[] pMtp;
            public double dAlign2;//对齐字段
            public int nMtp;//轨迹点数
            public byte bRealLl;	//tagOApiMapTrackPointV1中的经纬度是否真实经纬度
            public byte iTrackType;	// 轨迹类别: 自驾, 爬山 ...
            public byte iOverlayIdx;	//叠放层级
            public byte iShowLevel;//显示级别
            public byte iShowLevelMax;//show between iShowLevel-iShowLevelMax
            public byte bShowName;//是否显示轨迹名称
            public byte bEdit;//轨迹是否可编辑

            //六个自定义字段用于保存轨迹的自定义属性
            public byte iCustomType1;
            public byte iCustomType2;
            public byte iCustomType3;
            public byte iCustomType4;
            public int dwCustom1;
            public int dwCustom2;
            public tagOApiMapTrackDraw mtd;
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiRelatePointV1
        {
            public double lng;
            public double lat;
            public byte bReal;
            public double x;
            public double y;
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiSysCoorInfo
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
            public int[] ret;

            public int iCoorType;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] hash;	// 以下情况有效, 可用于判断是否发生了变化, [0, 奥维平面坐标, 4: 墨卡托坐标时]
            public int nInfoLen;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] strInfo;
        }

        //表示轨迹的结构体包含的点信息
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapTrackV2
        {
            //[MarshalAs(UnmanagedType.ByValArray, SizeConst = 100)]
            public tagOApiMapTrackPointV1[] pMtp;
        }

        //轨迹绘制的相关属性
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapTrackDraw
        {
            public uint dwLineClr;	//线条颜色
            public int iLineWidth;		//线宽
            public byte iLineAlpha;	//线条透明度
            public byte iShowType;		// 轨迹风格: 显示加权距离, CAD多线段 ...
            public byte iLineType;		//线型
            public byte bNeedDrawDetail;	//是否需要绘制角度、距离提示信息
            public byte bClose;			//是否闭合
        }
        //表示图形的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapShapeV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]

            public byte[] pstrComment;//标签备注
            public double dAlign1;


            // public tagOApiMapTrackPointV1[] pMtp;


            public int nMtp;//图形的节点数
            public byte bRealLl;

            //iShowFlag:0 不显示属性，1 显示名字 2 显示面积 3 显示名字与面积
            public byte iShowFlag;
            public byte iOverlayIdx;
            public double dStartAngle;	//当图形为两个点时，通过起始角度与终止角度表示圆、扇形、矩形
            double dEndAngle;

            public byte iLineWidth;	//线宽
            public byte iLineAlpha;	//线条透明度
            public byte iAreaAlpha;	//区域透明度
            public byte bEditMode;		//是否可编辑
            public byte iShowLevel;
            public byte iShowLevelMax;
            //外部Rgn索引，0为全部都是外部，>0为前面多少个是外部，后面是内部，用于处理镂空
            public byte iOuterRgnIdx;
            public uint dwLineClr;	//线条颜色
            public uint dwAreaClr;	//填充颜色
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }

        //表示图形包含的点信息
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapShapeV2
        {
            //[MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
            public tagOApiMapTrackPointV1[] pMtp;
        }
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiLatLngV1
        {
            public double lat;
            public double lng;

        }
        //表示一个导航步骤的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapDirectionsUnitV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 128)]
            public byte[] strTitle;//主步骤
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 1280)]
            public byte[,] strSubTitle;//子步骤
            public int nSubCount;	//子步骤数
            public short iType;	//交通工具类型
            public int nLl;		//llList个数



            public double dAlign1;

            // public tagOApiLatLngV1[] llList;


        }
        //表示导航路线的结构体
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapDirectionsV1
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_API_NAME_LEN)]
            public byte[] strName;//对象名称
            // public tagOApiMapDirectionsUnitV1[] pUnit;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] pstrComment;//标签备注
            public double dAlign1;


            public int nUnit;//导航步骤数
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 128)]
            public byte[] strTitle;
            public tagMapDirectionsSrh dirSrh;



            public byte bEdit;//是否可编辑

            public byte iLineWidth;	//线宽
            public byte iLineAlpha;	//透明度
            public uint dwLineClr;	//线条颜色
            public byte iOverlayIdx;	//叠放层级
            public byte bRealLl;		//是否真实经纬度

            public byte iShowLevel;	//显示级别
            public byte iShowLevelMax;//show between iShowLevel-iShowLevelMax
            [MarshalAsAttribute(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.U4)]
            public uint[] ret;
        }

        //表示导航路线包含的所有的点信息
        [StructLayout(LayoutKind.Sequential)]
        public struct tagOApiMapDirectionsV2
        {
            public tagOApiMapDirectionsUnitV1[] pUnit;
        }

        //搜索到的导航步骤
        [StructLayout(LayoutKind.Sequential)]
        public struct tagMapDirectionsSrh
        {
            public tagOApiLatLngV1 mpStart;//出发点的经纬度
            public tagOApiLatLngV1 mpEnd;//终点的经纬度
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public tagOApiLatLngV1[] mpVia;//中间导航点的经纬度
            public int iDirMode;//???
        }
        public const int OMAP_WIN_API_VERSION = 101;
        public const int OMAP_WIN_API_FLAG = 1001;

        public const int OMAP_WIN_CMD_REGISTER = 20000;
        public const int OMAP_WIN_CMD_GET_LATLNG = 20001;
        public const int OMAP_WIN_CMD_SET_LATLNG = 20002;
        public const int OMAP_WIN_CMD_LATLNG_GEOCODE = 20003;
        public const int OMAP_WIN_CMD_SHOW_PIC = 20004;
        public const int OMAP_WIN_CMD_TIME_TO_LATLNG = 20005;
        public const int OMAP_WIN_CMD_GET_VERSION = 20006;
        public const int OMAP_WIN_CMD_SET_MAP_LOCATION = 20007;
        public const int OMAP_WIN_CMD_CLOSE = 20008;
        public const int OMAP_WIN_CMD_SAVE_CFG = 20009;
        public const int OMAP_WIN_CMD_CLEAN_TMP_OBJ = 20010;
        public const int OMAP_WIN_CMD_SET_MAP_LOCATION_EXT = 20011;
        
        public const int OMAP_API_CMD_GET_OBJ_LIST = 20100;
        public const int OMAP_API_CMD_GET_OBJ = 20101;
        public const int OMAP_API_CMD_SET_OBJ = 20102;
        public const int OMAP_API_CMD_DEL_OBJ = 20103;
        public const int OMAP_API_CMD_GET_SEL_LIST =20104;
        public const int OMAP_API_CMD_SRH_OBJ =20105;

        public const int OMAP_API_CMD_SET_SYS_COOR_POINT =20201;
        public const int OMAP_API_CMD_GET_SYS_COOR_INFO =20202;
        
        public const int OMAP_API_CMD_GET_MAP_DATA	=20301;

        public const int OMAP_API_CMD_SET_BTN	=20401;
        public const int OMAP_API_CMD_CLICK_BTN	=20402;

        public const int OMAP_API_CMD_GET_STATUS_INFO=	20501;

        public const int OMAP_RET_SYS_COOR_TYPE_ERR=	-2;
        public const int OMAP_RET_SYS_COOR_SIM_PARAM_ERR=	-1;
        public const int OMAP_RET_SYS_COOR_OK = 0;

        public const int ACTION_MOUSE_MOVE = 1;
        public const int ACTION_MOUSE_CLICK = 2;

        public const int GEO_DECODE_ERR_WAIT = -1;
        public const int GEO_DECODE_ERR_NO_DATA = -2;
        public const int MAX_API_NAME_LEN = 100;
        public const int MAX_API_DIR_WAYPOINTS = 8;

        public const int OMAP_OBJ_TYPE_GROUP = 30;
        public const int OMAP_OBJ_TYPE_SIGN = 7;
        public const int OMAP_OBJ_TYPE_TRACK = 8;
        public const int OMAP_OBJ_TYPE_SHAPE = 13;
        public const int OMAP_OBJ_TYPE_DIR = 11;

        public const int OMAP_API_ERR_WND = -1;
        public const int OMAP_API_ERR_REGISTER = -2;
        public const int OMAP_API_ERR_VER = -3;
        public const int OMAP_API_ERR_ARGV = -4;
        public const int OMAP_API_ERR_NOT_VIP = -5;
        public const int OMAP_API_ERR_DEAL = -6;
        public const int OMAP_API_ERR_NOT_VIP5 =-7;
        public const int OMAP_API_ERR_UNLOAD_OBJ = -8;
        public const string APP_CLASS_NAME = "OMapApiTest";
        private const int GWL_STYLE = -16;
        private const int WS_CHILD = 0x40000000;
       
        public const int USER = 0x0400;
        public const int OAPI_LL_TYPE_DEFAULT =0;
        public const int OAPI_LL_TYPE_REAL	=1;
        public const int OAPI_LL_TYPE_OFFSET =2;
        public const int OAPI_LL_TYPE_PLANE =3;

        // 所有对象
        public const int OBJ_SELECT_CHECK_FLAG_ALL		=	0;
        // 选中对象, 选中的文件夹自动包含所有子对象
        public const int OBJ_SELECT_CHECK_FLAG_GROUP_JOIN	=1;
        // 选中对象, 选中的文件夹不自动包括非选中子对象
        public const int OBJ_SELECT_CHECK_FLAG_SEL_ONLY = 2;
        //临时对象分组节点ID
        public const int OMAP_TMP_OBJ_GROUP_ID = 202;

        public const int WM_COPYDATA = 0x004A;


        OMapApiRealize g_omapApi = new OMapApiRealize();


        [DllImport("user32.dll", EntryPoint = "SetParent")]
        public static extern int SetParent(IntPtr hWndChild, IntPtr hWndNewParent);

        [DllImport("user32.dll", EntryPoint = "GetWindowLong")]
        public static extern int GetWindowLong(IntPtr hwnd, int nIndex);

        [DllImport("user32.dll", EntryPoint = "SetWindowLong")]
        public static extern int SetWindowLong(IntPtr hwnd, int nIndex, int dwNewLong);

        [DllImport("user32.dll", EntryPoint = "FindWindow")]
        private extern static IntPtr FindWindow(string lpClassName, string lpWindowName);

        [DllImport("User32.dll", EntryPoint = "SendMessageA")]
        public static extern int SendMessage(
            IntPtr hWnd,　　　  // handle to destination window   
            int Msg,　　　      // message  
            int wParam,　   // first message parameter   
            ref COPYDATASTRUCT pcd // second message parameter   
        );
        [StructLayout(LayoutKind.Sequential)]
        public struct COPYDATASTRUCT
        {
            public IntPtr dwData;
            public int cbData;
            
            public IntPtr lpData;
        }
       
        public struct WNDCLASSEX
        {
            [MarshalAs(UnmanagedType.U4)]
            public int cbSize;
            [MarshalAs(UnmanagedType.U4)]
            public int style;
            public IntPtr lpfnWndProc;
            public int cbClsExtra;
            public int cbWndExtra;
            public IntPtr hInstance;
            public IntPtr hIcon;
            public IntPtr hCursor;
            public IntPtr hbrBackground;
            public string lpszMenuName;
            public string lpszClassName;
            public IntPtr hIconSm;
        }

        [DllImport("user32.dll")]
        static extern bool UpdateWindow(IntPtr hWnd);

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);

        public enum ShowCommands : int
        {
            SW_HIDE = 0,
            SW_SHOWNORMAL = 1,
            SW_NORMAL = 1,
            SW_SHOWMINIMIZED = 2,
            SW_SHOWMAXIMIZED = 3,
            SW_MAXIMIZE = 3,
            SW_SHOWNOACTIVATE = 4,
            SW_SHOW = 5,
            SW_MINIMIZE = 6,
            SW_SHOWMINNOACTIVE = 7,
            SW_SHOWNA = 8,
            SW_RESTORE = 9,
            SW_SHOWDEFAULT = 10,
            SW_FORCEMINIMIZE = 11,
            SW_MAX = 11
        }
        [DllImport("shell32.dll")]
        static extern IntPtr ShellExecute(
            IntPtr hwnd,
            string lpOperation,
            string lpFile,
            string lpParameters,
            string lpDirectory,
            ShowCommands nShowCmd);

        [DllImport("user32.dll", SetLastError = true, EntryPoint = "CreateWindowEx")]
        public static extern IntPtr CreateWindowEx(
           int dwExStyle,
           UInt16 regResult,
            //string lpClassName,
           string lpWindowName,
           UInt32 dwStyle,
           int x,
           int y,
           int nWidth,
           int nHeight,
           IntPtr hWndParent,
           IntPtr hMenu,
           IntPtr hInstance,
           IntPtr lpParam);

        public struct Rect
        {
            public int Left;
            public int Top;
            public int Right;
            public int Bottom;
        }
        [DllImport("user32.dll")]
        private static extern int GetWindowRect(IntPtr hwnd, out  Rect lpRect);

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern int SetWindowPos(IntPtr hWnd,IntPtr hWndInsertAfter,int X,int Y,int cx,int cy,uint uFlags);
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern System.IntPtr GetForegroundWindow();
        
        public OMapApiTest()
        {
            InitializeComponent();

        }

        public static byte[] StructToBytes(object structObj)
        {
            int size = Marshal.SizeOf(structObj);
            IntPtr buffer = Marshal.AllocHGlobal(size);
            try
            {
                Marshal.StructureToPtr(structObj, buffer, false);
                byte[] bytes = new byte[size];
                Marshal.Copy(buffer, bytes, 0, size);
                return bytes;
            }
            finally
            {
                Marshal.FreeHGlobal(buffer);
            }
        }

        private void IDC_BTN_GET_LATLNG_Click(object sender, EventArgs e)
        {
            int r = g_omapApi.SendMessageToOmap(OMAP_WIN_CMD_GET_LATLNG, null, 0);
            AlertErrSendOmapMsg(r);

        }

        private void IDC_BTN_SET_LATLNG_Click(object sender, EventArgs e)
        {
            g_omapApi.SetOmapTmpSign(40.12346, 116.23456, false);
        }

        private void IDC_BTN_SET_MAP_STA_Click(object sender, EventArgs e)
        {
            int r = g_omapApi.SetOmapLevelAndLocationExt(101, 16, 40437103.91, 2936164.61, 0, 2);
            AlertErrSendOmapMsg(r);
        }

        private void IDC_BTN_SET_PHOTOLIST_Click(object sender, EventArgs e)
        {
            tagOPhotoMapPic[] omp = new tagOPhotoMapPic[1000];

            for (int i = 0; i < 1000; i++)
            {
                omp[i] = new tagOPhotoMapPic();
                omp[i].idPic = i + 10000;
                omp[i].lat = 40.123456 + 0.001 * i;
                omp[i].lng = 116.123456 + 0.001 * i;

            }
            g_omapApi.SendMessagesToOmap(OMAP_WIN_CMD_SHOW_PIC, omp, 40000, omp.Length);//sizeof(omap)=4000;

        }

        public static object BytesToStruct(byte[] bytes, Type type)
        {
            int size = Marshal.SizeOf(type);
            IntPtr buffer = Marshal.AllocHGlobal(size);
            try
            {
                Marshal.Copy(bytes, 0, buffer, size);
                return Marshal.PtrToStructure(buffer, type);
            }
            finally
            {
                Marshal.FreeHGlobal(buffer);
            }
        }

        protected override void WndProc(ref Message m)
        {



            if (m.Msg == WM_COPYDATA && (int)m.WParam == OMAP_WIN_API_FLAG)
            {
                
                COPYDATASTRUCT pcd = new COPYDATASTRUCT();
                Type t = pcd.GetType();
                pcd = (COPYDATASTRUCT)m.GetLParam(t);
                int nAppId = ((int)(pcd.dwData) >> 16) & 0xffff;
                int nCmdId = (int)pcd.dwData & 0xffff;

                if (nCmdId == OMAP_WIN_CMD_GET_LATLNG)
                {
                    
                    tagOmapLatlng oll = new tagOmapLatlng();

                  
                   oll=(tagOmapLatlng) Marshal.PtrToStructure(pcd.lpData,typeof(tagOmapLatlng));
                   string ss = string.Format("{0:F5},{1:F5}", oll.lat, oll.lng);
                    
                    IDC_ED_RESULT.Text = ss;
                }
                else if (nCmdId == OMAP_WIN_CMD_SHOW_PIC)
                {
                    tagOPhotoMapPic pom = new tagOPhotoMapPic();
                    
                    int nPom = pcd.cbData / Marshal.SizeOf(pom);
                    pom = (tagOPhotoMapPic)Marshal.PtrToStructure(pcd.lpData, typeof(tagOPhotoMapPic));
                    string ss = string.Format("id={0},{1},{2},{3:F},{4:F}", pom.idPic, nPom, pom.iAction, pom.lat, pom.lng);
                    IDC_ED_RESULT.Text = ss;
                }
                else if (nCmdId == OMAP_WIN_CMD_LATLNG_GEOCODE)
                {
                    tagOmapGeoDecode pgd = new tagOmapGeoDecode();
                    pgd.strArea = new byte[1024];
                    pgd = (tagOmapGeoDecode)Marshal.PtrToStructure(pcd.lpData, typeof(tagOmapGeoDecode));
                    StringBuilder ss = new StringBuilder();
                    ss.AppendFormat("经纬度:{0:F},{1:F},解析结果:\r\n", pgd.oll.lat, pgd.oll.lng);
                    //如果是返回GEO_DECODE_ERR_WAIT，则需要等1秒后再请求，omap程序正从服务器下载行政地区数据
                    if (pgd.nLevel == GEO_DECODE_ERR_WAIT)
                    {
                        ss.AppendFormat("等待数据\r\n");
                    }
                    else if (pgd.nLevel == GEO_DECODE_ERR_NO_DATA)
                    {
                        ss.AppendFormat("找不到对应信息\r\n");
                    }
                    string[] newStrArea = new string[8];
                    byte[] str = new byte[128];
                    for (int i = 0; i < 8; i++)
                    {
                        for (int j = i * 128; j < 128 * (i + 1); j++)
                        {
                            str[j-(128*i)] += pgd.strArea[j];
                        }
                        newStrArea[i] = Encoding.UTF8.GetString(str);
                    }
                    for (int i = 0; i < pgd.nLevel; i++)
                    {
                        ss.AppendFormat("{0}\r\n", newStrArea[i]);
                    }
                    IDC_ED_RESULT.Text = ss.ToString();
                }
                else if (nCmdId == OMAP_WIN_CMD_TIME_TO_LATLNG)
                {
                    tagOPhotoMapPic pOmp = new tagOPhotoMapPic();


                    int nOmp = pcd.cbData / Marshal.SizeOf(pOmp);
                    
                    tagOPhotoMapPic[] Omps = new tagOPhotoMapPic[nOmp];
                    
                    byte[] ys = new byte[pcd.cbData];
                    Marshal.Copy(pcd.lpData, ys, 0, pcd.cbData);

                    for (int i = 0; i < nOmp; i++)
                    {
                        //循环取得数组内容  
                        
                        byte[] bytes = new byte[40];
                        Array.Copy(ys, i * 40, bytes,0, 40);
                        Omps[i] = (tagOPhotoMapPic)BytesToStruct(bytes, typeof(tagOPhotoMapPic));

                    }


                    int nCount = 0;
                    for (int i = 0; i < nOmp; i++)
                    {
                        if (Omps[i].lat != 0 || Omps[i].lng != 0)
                        {
                            Omps[i].lat += 0.0001*i;
                            Omps[i].lng += 0.0001*i;
                            nCount++;
                        }
                    }
                    StringBuilder ss = new StringBuilder();
                    ss.AppendFormat("共有{0}张照片获得经纬度:\r\n", nCount);

                    for (int i = 0; i < nOmp; i++)
                    {
                        if (Omps[i].lat != 0 || Omps[i].lng != 0)
                        {
                            ss.AppendFormat("第{0}张经纬度为:{1:F5},{2:F5}\r\n", i + 1, Omps[i].lat, Omps[i].lng);
                            
                        }
                    }
                    IDC_ED_RESULT.Text = ss.ToString();
                }
                else if (nCmdId == OMAP_API_CMD_GET_OBJ_LIST)
                {
                   
                    if (pcd.cbData == 0)
                    {
                        MessageBox.Show("当前奥维地图绑定用户不是VIP用户，不支持此API接口");
                        return;
                    }
                    byte[] pData = new byte[pcd.cbData];
                    Marshal.Copy(pcd.lpData, pData, 0, pcd.cbData);

                    int nList = (pcd.cbData - Marshal.SizeOf(new tagOApiObjectOptHdr())) / Marshal.SizeOf(new tagOApiItemListV1());
                    
                    tagOApiItemListV1[] pOlv = new tagOApiItemListV1[nList];
                    for (int i = 0; i < nList; i++)
                    {
                        //循环取得数组内容  

                        byte[] bytes = new byte[108];//tagOApiItemListV1 大小为108

                        Array.Copy(pData, (i * 108) + 16, bytes, 0, 108);//tagOApiObjectOptHdr 大小为16
                       
                        pOlv[i] = (tagOApiItemListV1)BytesToStruct(bytes, typeof(tagOApiItemListV1));

                    }

                    IDC_LT_RESULT.Clear();
                    IDC_LT_RESULT.Columns.Add("类别", 50);
                    IDC_LT_RESULT.Columns.Add("名字", 100);
                    IDC_LT_RESULT.ShowGroups = false;
                      
                    for (int i = 0; i < nList; i++)
                    {
                        string strType;

                        if (pOlv[i].iType == OMAP_OBJ_TYPE_GROUP)
                        {
                            strType = "文件夹";
                        }
                        else if (pOlv[i].iType == OMAP_OBJ_TYPE_SIGN)
                        {
                            strType = "标签";
                        }
                        else if (pOlv[i].iType == OMAP_OBJ_TYPE_TRACK)
                        {
                            strType = "轨迹";
                        }
                        else if (pOlv[i].iType == OMAP_OBJ_TYPE_SHAPE)
                        {
                            strType = "图形";
                        }
                        else if (pOlv[i].iType == OMAP_OBJ_TYPE_DIR)
                        {
                            strType = "路线";
                        }
                        else
                            strType = "未知";
                        
                        ListViewItem lvi = new ListViewItem(strType);
                        lvi.SubItems.Add(Encoding.UTF8.GetString(pOlv[i].strName).TrimEnd('\0'));
                        lvi.Tag = pOlv[i].idObj;
                        
                        this.IDC_LT_RESULT.Items.Add(lvi);

                    }
                    this.IDC_LT_RESULT.EndUpdate();
                }
                else if(nCmdId==OMAP_API_CMD_GET_SEL_LIST)
                {
                    if(pcd.cbData == 0)
                    {
                        MessageBox.Show("当前奥维地图绑定用户不是VIP用户，不支持此API接口");
                        return;
                    }

                    byte[] pData = new byte[pcd.cbData];
                    Marshal.Copy(pcd.lpData, pData, 0, pcd.cbData);
                    int nList = (pcd.cbData - Marshal.SizeOf(new tagOApiObjectOptHdr())) / Marshal.SizeOf(new tagOApiItemListV1());

                    tagOApiItemListV1[] pOlv = new tagOApiItemListV1[nList];
                    //循环取得数组内容  
                    for (int i = 0; i < nList; i++)
                    {

                        byte[] bytes = new byte[108];//tagOApiItemListV1 大小为108

                        Array.Copy(pData, (i * 108) + 16, bytes, 0, 108);//tagOApiObjectOptHdr 大小为16

                        pOlv[i] = (tagOApiItemListV1)BytesToStruct(bytes, typeof(tagOApiItemListV1));

                    }
                    //
                }
                else if(nCmdId == OMAP_API_CMD_SRH_OBJ)
                {
                    if(pcd.cbData==0)
                    {
                        MessageBox.Show("当前奥维地图绑定用户不是VIP用户，不支持此API接口");
                        return;
                    }
                    byte[] pData = new byte[pcd.cbData];
                    Marshal.Copy(pcd.lpData, pData, 0, pcd.cbData);
                    int nList = (pcd.cbData - Marshal.SizeOf(new tagOApiObjectOptHdr())) / Marshal.SizeOf(new tagOApiItemListV1());

                    tagOApiItemListV1[] pOlv = new tagOApiItemListV1[nList];
                    //循环取得数组内容  
                    for (int i = 0; i < nList; i++)
                    {

                        byte[] bytes = new byte[108];//tagOApiItemListV1 大小为108

                        Array.Copy(pData, (i * 108) + 16, bytes, 0, 108);//tagOApiObjectOptHdr 大小为16

                        pOlv[i] = (tagOApiItemListV1)BytesToStruct(bytes, typeof(tagOApiItemListV1));

                    }
                    //
                }
                else if (nCmdId == OMAP_API_CMD_GET_MAP_DATA)
                {
                    if (pcd.cbData == 0)
                    {
                        MessageBox.Show("当前奥维地图绑定用户不是VIP用户，不支持此API接口");
                        return;
                    }

                    byte[] pData = new byte[pcd.cbData];
                    Marshal.Copy(pcd.lpData, pData, 0, pcd.cbData);
                    tagOApiObjectOptHdr pOoh = new tagOApiObjectOptHdr();
                    byte[] bytes = new byte[Marshal.SizeOf(pOoh)];
                    
                    Array.Copy(pData, 0, bytes, 0, Marshal.SizeOf(pOoh));//tagOApiObjectOptHdr大小为16
                    pOoh = (tagOApiObjectOptHdr)BytesToStruct(bytes, typeof(tagOApiObjectOptHdr));

                    tagOmapGetMap pGet = new tagOmapGetMap();
                    byte[] bytess = new byte[Marshal.SizeOf(pGet)];

                    Array.Copy(pData, Marshal.SizeOf(pOoh), bytess, 0, Marshal.SizeOf(pGet));
                    pGet = (tagOmapGetMap)BytesToStruct(bytess, typeof(tagOmapGetMap));

                    int nDataIng = (pcd.cbData - Marshal.SizeOf(new tagOApiObjectOptHdr())- Marshal.SizeOf(new tagOmapGetMap()));
                    if (nDataIng <= 0)
                    {
                        MessageBox.Show("未知错误");
                        return;
                    }
                    byte[] pDataImg = new byte[nDataIng];
                    Array.Copy(pData, Marshal.SizeOf(new tagOApiObjectOptHdr()) + Marshal.SizeOf(new tagOmapGetMap()), pDataImg, 0, nDataIng);

                    
                }
                else if(nCmdId == OMAP_API_CMD_GET_OBJ)
                {

                    StringBuilder ss = new StringBuilder();
                    byte[] pData = new byte[pcd.cbData];
                    Marshal.Copy(pcd.lpData, pData, 0, pcd.cbData);
                    tagOApiObjectOptHdr pOoh= new tagOApiObjectOptHdr();
                    byte[] bytes = new byte[Marshal.SizeOf(pOoh)];
                    

                    Array.Copy(pData, 0, bytes, 0, Marshal.SizeOf(pOoh));//tagOApiObjectOptHdr大小为16
                      pOoh = (tagOApiObjectOptHdr)BytesToStruct(bytes, typeof(tagOApiObjectOptHdr));
                    if(pOoh.iType==OMAP_OBJ_TYPE_GROUP)
                    {
                        OmapInterface.OMapApiRealize.tagOApiObjGroupV1 pGroup = g_omapApi.GetOmapGroupFromBuf(pData, pcd.cbData - Marshal.SizeOf(new tagOApiObjectOptHdr()));

                        ss.AppendFormat("name={0}\r\n", Encoding.UTF8.GetString(pGroup.strName).TrimEnd('\0'));
                         ss.AppendFormat("child={0}\r\n",pGroup.nChild);
                        
                    }
                    else if(pOoh.iType == OMAP_OBJ_TYPE_SIGN)
                    {
                        OmapInterface.OMapApiRealize.tagOApiMapSignV1 pSign = g_omapApi.GetOmapSignFromBuf(pData, pcd.cbData - Marshal.SizeOf(new tagOApiObjectOptHdr()));
                        ss.AppendFormat("name={0}\r\n", Encoding.UTF8.GetString(pSign.strName).TrimEnd('\0'));
                        ss.AppendFormat("latlng={0:F},{1:F}\r\n",pSign.lat,pSign.lng);
                    }
                    else if(pOoh.iType==OMAP_OBJ_TYPE_TRACK)
                    {
                        OmapInterface.OMapApiRealize.tagOApiMapTrackV1 pTrack = g_omapApi.GetOmapTrackFromBuf(pData, pcd.cbData - Marshal.SizeOf(new tagOApiObjectOptHdr()));
                        ss.AppendFormat("name={0}\r\n", Encoding.UTF8.GetString(pTrack.strName).TrimEnd('\0'));
                        ss.AppendFormat("TrackPointCount={0}\r\n",pTrack.nMtp);
                    }
                    else if (pOoh.iType == OMAP_OBJ_TYPE_SHAPE)
                    {
                        OmapInterface.OMapApiRealize.tagOApiMapShapeV1 pShape = g_omapApi.GetOmapShapeFromBuf(pData, pcd.cbData - Marshal.SizeOf(new tagOApiObjectOptHdr()));
                        ss.AppendFormat("name={0}\r\n", Encoding.UTF8.GetString(pShape.strName).TrimEnd('\0'));
                        ss.AppendFormat("VertexCount={0}\r\n", pShape.nMtp);
                    }
                    else if(pOoh.iType == OMAP_OBJ_TYPE_DIR)
                    {
                        OmapInterface.OMapApiRealize.tagOApiMapDirectionsV1 pDir= g_omapApi.GetOmapDirFromBuf(pData, pcd.cbData - Marshal.SizeOf(new tagOApiObjectOptHdr()));
                      
                        ss.AppendFormat("name={0}\r\n", Encoding.UTF8.GetString(pDir.strName).TrimEnd('\0'));
                        ss.AppendFormat("nUnit={0}\r\n", pDir.nUnit);
                    }
                    else
                    {
                        ss.AppendFormat("不支持的对象");
                    }
                    IDC_ED_RESULT.Text = ss.ToString();
                }
                else if (nCmdId == OMAP_API_CMD_SET_BTN)
                {
                    if (pcd.cbData < sizeof(int))
                        return;
                    //返回状态
                    int iAdd = 0;
                    byte[] pData = new byte[pcd.cbData];
                    Marshal.Copy(pcd.lpData, pData, 0, pcd.cbData);

                    byte[] intBuff = new byte[sizeof(int)];
                    Array.Copy(pData, 0, intBuff, 0, sizeof(int));
                    iAdd = BitConverter.ToInt32(intBuff, 0);
                }
                else if (nCmdId == OMAP_API_CMD_CLICK_BTN)
		        {
			        // 奥维地图用户按下附件按钮
		        }
		        else if (nCmdId == OMAP_WIN_CMD_SAVE_CFG)
		        {
		        	//奥维地图用户按下保存配置按钮
	        	}
	        	else if (nCmdId == OMAP_API_CMD_SET_SYS_COOR_POINT)
                {
                    if (pcd.cbData < sizeof(int))
                        return;
                    int iRet = 0;
                    byte[] pData = new byte[pcd.cbData];
                    Marshal.Copy(pcd.lpData, pData, 0, pcd.cbData);

                    byte[] intBuff = new byte[sizeof(int)];
                    Array.Copy(pData, 0, intBuff, 0, sizeof(int));
                    iRet = BitConverter.ToInt32(intBuff, 0);
                }
                else if(nCmdId==OMAP_API_CMD_GET_SYS_COOR_INFO)
                {
                    if (pcd.cbData < Marshal.SizeOf(new tagOApiSysCoorInfo()))
                        return;

                    byte[] pBuf = new byte[pcd.cbData];
                    Marshal.Copy(pcd.lpData, pBuf, 0, pcd.cbData);

                    tagOApiSysCoorInfo osi = new tagOApiSysCoorInfo();
                    byte[] bytes = new byte[Marshal.SizeOf(osi)];
                    Array.Copy(pBuf, 0, bytes, 0, Marshal.SizeOf(osi));
                    osi = (tagOApiSysCoorInfo)BytesToStruct(bytes, typeof(tagOApiSysCoorInfo));

                    Array.Copy(pBuf, Marshal.SizeOf(osi), osi.strInfo, 0, pcd.cbData - Marshal.SizeOf(osi));

                }
            }

            base.WndProc(ref m);
        }


        void AlertErrSendOmapMsg(int ret)
        {
            if (ret >= 0)
                return;
            if (ret == OMAP_API_ERR_WND)
            {
                MessageBox.Show("没有找到奥维地图程序窗口");
            }
            else if (ret == OMAP_API_ERR_REGISTER)
            {
                MessageBox.Show("向奥维地图程序注册失败");
            }
            else if (ret == OMAP_API_ERR_VER)
            {
                MessageBox.Show("奥维地图程序版本太低");
            }
            else if (ret == OMAP_API_ERR_ARGV)
            {
                MessageBox.Show("参数非法");
            }
            else if (ret == OMAP_API_ERR_NOT_VIP)
            {
                MessageBox.Show("当前奥维地图绑定用户不是VIP用户，不支持此API接口");
            }
            else if (ret == OMAP_API_ERR_DEAL)
            {
                MessageBox.Show("消息处理失败");
            }
            else
            {
                MessageBox.Show("未知错误");
            }
        }
        public static bool IsNumeric(string value)
        {
            return Regex.IsMatch(value, @"^[+-]?\d*[.]?\d*$");
        }
        private void IDC_BTN_LATLNG_DECODE_Click(object sender, EventArgs e)
        {

            double lng = 0, lat = 0;
            string ss = IDC_EDIT_LL.Text;
            string[] s = ss.Split(',');
            if (s.Length != 2 || !IsNumeric(s[0]) || !IsNumeric(s[1]))
            {
                MessageBox.Show("经纬度格式错误!");
                lat = 40.12345;
                lng = 116.22334;
            }
            else
            {
                lat = double.Parse(s[0]);
                lng = double.Parse(s[1]);
                
            }
            g_omapApi.GeoDecodeLatlng(lat, lng, false);
        }

        private void IDC_BTN_GET_LATLNG_BY_TIME_Click(object sender, EventArgs e)
        {
            tagOPhotoMapPic[] omp = new tagOPhotoMapPic[100];
            for (int i = 0; i < 100; i++)
            {
                omp[i] = new tagOPhotoMapPic();
                omp[i].tmPhoto = (uint)(DateTime.Now.Subtract(DateTime.Parse("1970-1-1")).TotalMilliseconds - 86400 + i * 60);
               
            }
            g_omapApi.SendMessagesToOmap(OMAP_WIN_CMD_TIME_TO_LATLNG, omp, 4000, 100);
        }

        private void IDC_BTN_GET_OBJ_LIST_Click(object sender, EventArgs e)
        {
            uint idParent = 0;
            int nSelect = IDC_LT_RESULT.SelectedItems.Count;
            
            if (nSelect > 0)
            {
                string strType = IDC_LT_RESULT.Items[0].Text;
                if (strType == "文件夹")
                {

                    idParent = (uint)IDC_LT_RESULT.SelectedItems[0].Tag;
                }
                
            }
            int r = g_omapApi.GetOmapObjectList(idParent);
            AlertErrSendOmapMsg(r);
        }

        private void IDC_BTN_GET_OBJ_Click(object sender, EventArgs e)
        {

            int nSelect = IDC_LT_RESULT.SelectedItems.Count;
            if(nSelect<=0)
            {
                MessageBox.Show("请选择对象");
                return;
            }
            uint idObj = (uint)IDC_LT_RESULT.SelectedItems[0].Tag;
           
            int r = g_omapApi.GetOmapObject(idObj,0);
            AlertErrSendOmapMsg(r);
            

        }
       

        private void IDC_BTN_SET_OBJ_Click(object sender, EventArgs e)
        {
            uint idParent = 0;
            int nSelect = IDC_LT_RESULT.SelectedItems.Count;

            if (nSelect > 0)
            {
                string strType = IDC_LT_RESULT.Items[0].Text;
                if (strType == "文件夹")
                {

                    idParent = (uint)IDC_LT_RESULT.SelectedItems[0].Tag;
                }

            }
            SetObjectToOmap(idParent);
            IDC_BTN_GET_OBJ_LIST_Click(sender, e);
            
        }

        public void SetObjectToOmap(uint idParent)
        {


            //往指定目录添加一个文件夹
            String strName = "我的文件夹";
            int r;
            OmapInterface.OMapApiRealize.tagOApiObjGroupV1 pGroup = g_omapApi.NewOmapGroup();
            pGroup.strName = Encoding.UTF8.GetBytes(strName.Trim().PadRight(90, '\0'));
            r = g_omapApi.SetOmapObject(0, pGroup, idParent, 0);
            AlertErrSendOmapMsg(r);
            if (r != 0)
                return;

            //将奥维地图设为卫星图并转到相关位置上
            g_omapApi.SetOmapLevelAndLocation(101, 16, 116.2222, 40.1111);

            //往指定目录添加一个标签
            strName = "我的标签";
            OmapInterface.OMapApiRealize.tagOApiMapSignV1 pSign = g_omapApi.NewOmapSign();
            pSign.strName = Encoding.UTF8.GetBytes(strName.Trim().PadRight(92, '\0'));
            pSign.pstrComment = Encoding.UTF8.GetBytes("test Sign");
            pSign.lat = 40.1111;
            pSign.lng = 116.2222;
            pSign.iSignPic = 1;
            pSign.iTxtType = 1;
            r = g_omapApi.SetOmapObject(0, pSign, idParent, 0);
            AlertErrSendOmapMsg(r);
            if (r != 0)
                return;

            //往指定目录添加一条轨迹

            strName = "我的轨迹";

            OmapInterface.OMapApiRealize.tagOApiMapTrackV1 pTrack = g_omapApi.NewOmapTrack();
            pTrack.strName = Encoding.UTF8.GetBytes(strName.Trim().PadRight(92, '\0'));
            strName = "备注12";
            pTrack.pstrComment = Encoding.UTF8.GetBytes(strName.Trim().PadRight(2, '\0'));
            pTrack.mtd.dwLineClr = (uint)Color.FromArgb(0, 244, 244).ToArgb();
            pTrack.nMtp = 100;

            r = g_omapApi.SetOmapObject(0, pTrack, idParent, 0);
            AlertErrSendOmapMsg(r);
            if (r != 0)
                return;

            //往指定目录添加一个图形
            strName = "我的图形";
            OmapInterface.OMapApiRealize.tagOApiMapShapeV1 pShape = g_omapApi.NewOmapShape();
            pShape.strName = Encoding.UTF8.GetBytes(strName.Trim().PadRight(100, '\0'));
            strName = "abcdefg我的图形";
            pShape.pstrComment = Encoding.UTF8.GetBytes(strName.Trim().PadRight(0, '\0'));
            pShape.nMtp = 10;
            r = g_omapApi.SetOmapObject(0, pShape, idParent, 0);
            AlertErrSendOmapMsg(r);
            if (r != 0)
                return;

            //往指定目录添加一条线路

            strName = "我的线路";
            OmapInterface.OMapApiRealize.tagOApiMapDirectionsV1 pDir = g_omapApi.NewOmapDir();
            pDir.strName = Encoding.UTF8.GetBytes(strName.Trim().PadRight(92, '\0'));
            strName = "abcdefg我的线路ffss";
            pDir.pstrComment = Encoding.UTF8.GetBytes(strName.Trim().PadRight(0, '\0'));
            pDir.strTitle = Encoding.Default.GetBytes("test dir".Trim().PadRight(128, '\0'));
            pDir.nUnit = 10;
           
            r = g_omapApi.SetOmapObject(0, pDir, idParent, 0);
            
            AlertErrSendOmapMsg(r);
        }

        private void IDC_BTN_DEL_OBJ_Click(object sender, EventArgs e)
        {
            int nSelect = IDC_LT_RESULT.SelectedItems.Count;
            if(nSelect==0)
            {
                MessageBox.Show("请选择要删除的对象");
                return;
            }
            if (MessageBox.Show("您确定要删除所选定的对象吗？", "提示窗", MessageBoxButtons.OKCancel, MessageBoxIcon.Asterisk) == DialogResult.No)
            {
                return;
            }
            uint[] pdwObj = new uint[nSelect];
            if (nSelect == 1)
            {
                    pdwObj[0] = (uint)IDC_LT_RESULT.SelectedItems[0].Tag;
            }
            else
            {
                for (int i = 0; i < nSelect; i++)
                    pdwObj[i] = (uint)IDC_LT_RESULT.SelectedItems[i].Tag;
            }
            

            int r = g_omapApi.DelOmapObject(pdwObj, nSelect);
            AlertErrSendOmapMsg(r);

            if(r==0)
            {

                for (int i = nSelect - 1; i >= 0; i--)
                {
                    ListViewItem item = IDC_LT_RESULT.SelectedItems[i];
                    IDC_LT_RESULT.Items.Remove(item);
                }
            }

        }

        private void IDC_BTN_SET_TMP_OBJ_Click(object sender, EventArgs e)
        {
            SetObjectToOmap(OMAP_TMP_OBJ_GROUP_ID);
        }

        private void IDC_BTN_CLEAN_TMP_OBJ_Click(object sender, EventArgs e)
        {
            g_omapApi.CleanOmapTmpObject();
        }

        private void IDC_BTN_GET_OMAP_VER_Click(object sender, EventArgs e)
        {
            bool flag = true;
            RegistryKey key = Registry.CurrentUser;
            RegistryKey subKey = key.OpenSubKey("Software\\Ovital Software\\omap\\MainFrm");
            int iVersion = 0;
            string strAppPath;
            iVersion = (int)subKey.GetValue("LastVersion");
            strAppPath = (string)subKey.GetValue("LastRunPath");
            key.Close();
            IntPtr hwnd = FindWindow("omapWin", null);
            StringBuilder strInfo = new StringBuilder();
            strInfo.AppendFormat("版本号:{0}.{1}.{2}\n路径:{3}", iVersion / 100, iVersion % 100 / 10, iVersion % 10, strAppPath);
            if (hwnd == IntPtr.Zero)
            {
                strInfo.AppendFormat("\n未找到奥维地图程序窗口，是否要启动奥维?");
                flag = false;
            }
            if (flag)
                MessageBox.Show(strInfo.ToString());
            else
            {

                if (MessageBox.Show(strInfo.ToString(), "提示", MessageBoxButtons.OKCancel, MessageBoxIcon.Asterisk) == DialogResult.OK)
                {
                    System.Diagnostics.Process.Start(strAppPath);
                }


            }

        }

        private void IDC_BTN_SHOW_TOOLBOX_Click(object sender, EventArgs e)
        {
            
           
            IntPtr hwnd = FindWindow("omapWin", null);
           
            if (hwnd != IntPtr.Zero)
            {
                Form1 f = new Form1();
                f.ShowInTaskbar = false;
                this.Visible = false;
                f.ShowDialog();
                
                
                this.Close();
                
            }else
            {
                MessageBox.Show("没有找到奥维地图");
            }

        }

        private void OMapApiTest_Load(object sender, EventArgs e)
        {

            this.IDC_LT_RESULT.Columns.Add("类别", 50);
            this.IDC_LT_RESULT.Columns.Add("名字", 100);
            IDC_LT_RESULT.ShowGroups = false;
            
        }

        private void OMapApiTest_Load_1(object sender, EventArgs e)
        {
            this.IDC_LT_RESULT.Columns.Add("类别", 50);
            this.IDC_LT_RESULT.Columns.Add("名字", 100);
            IDC_LT_RESULT.ShowGroups = false;
        }



    }
}